﻿namespace LabsB.Controls.Design
{
    using System;
    using System.CodeDom;
    using System.ComponentModel;
    using System.ComponentModel.Design.Serialization;
    using System.Windows.Forms;

    public class ActiveDocumentHostCodeDomSerializer : CodeDomSerializer
    {
        private static readonly Attribute[] designTimeProperties = new Attribute[] { DesignOnlyAttribute.Yes };
        private static readonly Attribute[] runTimeProperties = new Attribute[] { DesignOnlyAttribute.No };

        public override object Deserialize(IDesignerSerializationManager manager, object codeObject)
        {
            return this.GetBaseSerializer(manager).Deserialize(manager, codeObject);
        }

        private CodeDomSerializer GetBaseSerializer(IDesignerSerializationManager manager)
        {
            return (CodeDomSerializer) manager.GetSerializer(typeof(Component), typeof(CodeDomSerializer));
        }

        public override object Serialize(IDesignerSerializationManager manager, object value)
        {
            object obj2 = ((CodeDomSerializer) manager.GetSerializer(typeof(ImageList).BaseType, typeof(CodeDomSerializer))).Serialize(manager, value);
            CodeStatementCollection statements = obj2 as CodeStatementCollection;
            if (statements == null)
            {
                return obj2;
            }
            foreach (CodeObject obj3 in statements)
            {
                if ((obj3 is CodeAssignStatement) && (((CodeAssignStatement) obj3).Right is CodeFieldReferenceExpression))
                {
                    CodeFieldReferenceExpression right = (CodeFieldReferenceExpression) ((CodeAssignStatement) obj3).Right;
                    string fieldName = right.FieldName;
                    SplitterPanel instance = manager.GetInstance(fieldName) as SplitterPanel;
                    if (instance != null)
                    {
                        Control parent = instance.Parent;
                        string str2 = parent.Name + "." + ((((SplitContainer) parent).Panel1 == instance) ? "Panel1" : "Panel2");
                        ((CodeFieldReferenceExpression) ((CodeAssignStatement) obj3).Right).FieldName = str2;
                    }
                }
            }
            return statements;
        }
    }
}

