﻿namespace System.Windows.Forms.Design
{
    using System;
    using System.ComponentModel;
    using System.Drawing.Design;
    using System.Windows.Forms;

    internal class ActiveDocumentTypeEditor : UITypeEditor
    {
        private InsertableObjectPicker pickerDialog;

        public override object EditValue(ITypeDescriptorContext context, IServiceProvider provider, object value)
        {
            if (provider != null)
            {
                IWindowsFormsEditorService service = (IWindowsFormsEditorService) provider.GetService(typeof(IWindowsFormsEditorService));
                if (service == null)
                {
                    return value;
                }
                if (this.pickerDialog == null)
                {
                    this.pickerDialog = new InsertableObjectPicker();
                }
                if (value is string)
                {
                    this.pickerDialog.ProgId = (string) value;
                }
                if (service.ShowDialog(this.pickerDialog) == DialogResult.OK)
                {
                    value = this.pickerDialog.ProgId;
                }
            }
            return value;
        }

        public override UITypeEditorEditStyle GetEditStyle(ITypeDescriptorContext context)
        {
            return UITypeEditorEditStyle.Modal;
        }
    }
}

