using System;
using System.Design;
using System.Drawing;
using System.IO;
using System.Windows.Forms;
namespace LabsB.Controls.Design
{
	internal class InsertableObjectPicker : Form
	{
		private Button btnOK;
		private Button btnCancel;
		private RadioButton rbCreateNew;
		private RadioButton rbFromFile;
		private Button btnBrowse;
		private InsertableObjectList insertableObjectList1;
		private TextBox txtFileName;
		private OpenFileDialog openFileDialog1;
		private string progId;
		private string fileName;
		private bool bindingsSet;
		public string ProgId
		{
			get
			{
				if (this.insertableObjectList1 != null)
				{
					return this.insertableObjectList1.SelectedItemProgId;
				}
				return this.progId;
			}
			set
			{
				if (this.progId != value)
				{
					if (this.insertableObjectList1 != null)
					{
						this.insertableObjectList1.SelectedItemProgId = value;
					}
					this.progId = value;
				}
			}
		}
		public string FileName
		{
			get
			{
				if (this.txtFileName != null)
				{
					return this.txtFileName.Text;
				}
				return this.fileName;
			}
			set
			{
				this.fileName = value;
				if (this.txtFileName != null)
				{
					this.txtFileName.Text = value;
				}
			}
		}
		public bool FileSelected
		{
			get
			{
				return this.rbFromFile != null && this.rbFromFile.Checked;
			}
		}
		internal InsertableObjectPicker()
		{
			this.InitializeComponent();
		}
		internal InsertableObjectPicker(string progId) : this()
		{
			this.ProgId = progId;
		}
		private void InitializeComponent()
		{
			this.btnOK = new System.Windows.Forms.Button();
			this.btnCancel = new System.Windows.Forms.Button();
			this.rbCreateNew = new System.Windows.Forms.RadioButton();
			this.rbFromFile = new System.Windows.Forms.RadioButton();
			this.btnBrowse = new System.Windows.Forms.Button();
			this.insertableObjectList1 = new LabsB.Controls.Design.InsertableObjectList();
			this.txtFileName = new System.Windows.Forms.TextBox();
			this.openFileDialog1 = new System.Windows.Forms.OpenFileDialog();
			this.SuspendLayout();
			// 
			// btnOK
			// 
			this.btnOK.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnOK.Location = new System.Drawing.Point(341, 230);
			this.btnOK.Name = "btnOK";
			this.btnOK.Size = new System.Drawing.Size(96, 25);
			this.btnOK.TabIndex = 6;
			this.btnOK.Text = "OKCaption";
			this.btnOK.Click += new System.EventHandler(this.btnOK_Click);
			// 
			// btnCancel
			// 
			this.btnCancel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btnCancel.Location = new System.Drawing.Point(447, 230);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.Size = new System.Drawing.Size(96, 25);
			this.btnCancel.TabIndex = 7;
			this.btnCancel.Text = "CancelCaption";
			this.btnCancel.Click += new System.EventHandler(this.btnCancel_Click);
			// 
			// rbCreateNew
			// 
			this.rbCreateNew.Checked = true;
			this.rbCreateNew.Location = new System.Drawing.Point(10, 9);
			this.rbCreateNew.Name = "rbCreateNew";
			this.rbCreateNew.Size = new System.Drawing.Size(120, 25);
			this.rbCreateNew.TabIndex = 1;
			this.rbCreateNew.TabStop = true;
			this.rbCreateNew.Text = "InsertObjectDialogCreateNew";
			// 
			// rbFromFile
			// 
			this.rbFromFile.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.rbFromFile.Location = new System.Drawing.Point(10, 178);
			this.rbFromFile.Name = "rbFromFile";
			this.rbFromFile.Size = new System.Drawing.Size(180, 26);
			this.rbFromFile.TabIndex = 2;
			this.rbFromFile.Text = "InsertObjectDialogFromFile";
			// 
			// btnBrowse
			// 
			this.btnBrowse.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnBrowse.Enabled = false;
			this.btnBrowse.Location = new System.Drawing.Point(447, 178);
			this.btnBrowse.Name = "btnBrowse";
			this.btnBrowse.Size = new System.Drawing.Size(96, 25);
			this.btnBrowse.TabIndex = 5;
			this.btnBrowse.Text = "InsertObjectDialogBrowse";
			this.btnBrowse.Click += new System.EventHandler(this.btnBrowse_Click);
			// 
			// insertableObjectList1
			// 
			this.insertableObjectList1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
            | System.Windows.Forms.AnchorStyles.Left) 
            | System.Windows.Forms.AnchorStyles.Right)));
			this.insertableObjectList1.Location = new System.Drawing.Point(163, 9);
			this.insertableObjectList1.Name = "insertableObjectList1";
			this.insertableObjectList1.SelectedItemGuid = new System.Guid("00000000-0000-0000-0000-000000000000");
			this.insertableObjectList1.SelectedItemProgId = null;
			this.insertableObjectList1.Size = new System.Drawing.Size(380, 161);
			this.insertableObjectList1.TabIndex = 3;
			this.insertableObjectList1.ItemSelected += new System.EventHandler(this.insertableObjectList1_ItemSelected);
			// 
			// txtFileName
			// 
			this.txtFileName.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
            | System.Windows.Forms.AnchorStyles.Right)));
			this.txtFileName.AutoCompleteMode = System.Windows.Forms.AutoCompleteMode.SuggestAppend;
			this.txtFileName.AutoCompleteSource = System.Windows.Forms.AutoCompleteSource.RecentlyUsedList;
			this.txtFileName.Location = new System.Drawing.Point(163, 178);
			this.txtFileName.Name = "txtFileName";
			this.txtFileName.Size = new System.Drawing.Size(274, 21);
			this.txtFileName.TabIndex = 4;
			// 
			// openFileDialog1
			// 
			this.openFileDialog1.Title = "InsertObjectDialogBrowseCaption";
			// 
			// InsertableObjectPicker
			// 
			this.AcceptButton = this.btnOK;
			this.AutoScaleBaseSize = new System.Drawing.Size(6, 14);
			this.CancelButton = this.btnCancel;
			this.ClientSize = new System.Drawing.Size(552, 261);
			this.Controls.Add(this.txtFileName);
			this.Controls.Add(this.insertableObjectList1);
			this.Controls.Add(this.btnBrowse);
			this.Controls.Add(this.rbFromFile);
			this.Controls.Add(this.rbCreateNew);
			this.Controls.Add(this.btnCancel);
			this.Controls.Add(this.btnOK);
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.MinimumSize = new System.Drawing.Size(470, 224);
			this.Name = "InsertableObjectPicker";
			this.ShowInTaskbar = false;
			this.Text = "InsertObjectDialogCaption";
			this.Load += new System.EventHandler(this.InsertableObjectPicker_Load);
			this.ResumeLayout(false);
			this.PerformLayout();

		}
		private void btnOK_Click(object sender, EventArgs e)
		{
			base.Hide();
			base.DialogResult = DialogResult.OK;
		}
		private void btnCancel_Click(object sender, EventArgs e)
		{
			base.Hide();
		}
		private void insertableObjectList1_ItemSelected(object sender, EventArgs e)
		{
			this.btnOK.PerformClick();
		}
		private void InsertableObjectPicker_Load(object sender, EventArgs e)
		{
			this.txtFileName.Text = this.fileName;
			if (!this.bindingsSet)
			{
				this.insertableObjectList1.DataBindings.Add("Enabled", this.rbCreateNew, "Checked");
				this.txtFileName.DataBindings.Add("Enabled", this.rbFromFile, "Checked");
				this.btnBrowse.DataBindings.Add("Enabled", this.rbFromFile, "Checked");
				this.bindingsSet = true;
			}
		}
		private void btnBrowse_Click(object sender, EventArgs e)
		{
			try
			{
				if (this.FileName != null && this.FileName.Length != 0)
				{
					string directoryName = Path.GetDirectoryName(this.FileName);
					if (File.Exists(directoryName))
					{
						this.openFileDialog1.RestoreDirectory = false;
						this.openFileDialog1.InitialDirectory = directoryName;
					}
					else
					{
						this.openFileDialog1.RestoreDirectory = true;
					}
				}
			}
			catch
			{
				this.openFileDialog1.RestoreDirectory = true;
			}
			if (DialogResult.OK == this.openFileDialog1.ShowDialog(this))
			{
				this.FileName = this.openFileDialog1.FileName;
			}
		}
	}
}
