﻿namespace LabsB.Controls
{
    using Microsoft.Win32;
    using System;
    using System.Collections;
    using System.ComponentModel;
    using System.ComponentModel.Design.Serialization;
    using System.Diagnostics;
    using System.Drawing;
    using System.Drawing.Design;
    using System.IO;
    using System.Runtime.InteropServices;
    using System.Runtime.InteropServices.ComTypes;
    using System.Security.Permissions;
    using System.Windows.Forms.ComponentModel.Com2Interop;
	using System.Windows.Forms;


	
    [DefaultProperty("SourceDocument")]
	[DefaultEvent("Loaded")]
	//[Designer("LabsB.Controls.Design.ActiveDocumentHostDesigner," + Common.DesignDll)]
	//[ToolboxItem("LabsB.Controls.Design.ActiveDocumentHostToolboxItem," + Common.DesignDll)]
	[ToolboxItem(true)]
	[ToolboxBitmap("LabsB.Controls.ActiveDocumentHost.bmp")]
	//[DesignerSerializer("LabsB.Controls.Design.ActiveDocumentHostCodeDomSerializer," + Common.DesignDll, "System.ComponentModel.Design.Serialization.CodeDomSerializer, System.Design, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a")]
	[SecurityPermission(SecurityAction.Demand, Flags=SecurityPermissionFlag.UnmanagedCode)]
	[PermissionSet(SecurityAction.InheritanceDemand, Name="FullTrust")]
    public class ActiveDocumentHost : ScrollableControl, ISupportInitialize
    {
        private ActivationGesture activationGesture;
        private ActivationState activationState;
		private DocumentSizeMode sizeMode;
		private System.Windows.Forms.BorderStyle borderStyle;

		private ScrollableControl toolTarget;
		private UnsafeNativeMethods.IOleObject pOleObject;
		private UnsafeNativeMethods.IStorage storage;
        private ActiveDocumentContainer adcontainer;
        private ActiveDocumentSite adsite;

        private static object EventActivated = new object();
        private static object EventDeactivated = new object();
        private static object EventDocumentModified = new object();
        private static object EventLoaded = new object();
        private static object EventSaved = new object();
        private static object EventStatusTextChanged = new object();


        private int flags;
		private System.Guid guid;
		private string progId;
		private string sourceDoc;
		private string statusText;


		#region Flags
		private const int GuidSet = 1;
		private const int ProgIdSet = 2;
		private const int FlagShowToolbars = 4;
        private const int FlagShowMenus = 8;
		private const int SourceDocSet = 0x10;
		private const int SourceDataSet = 0x20;
		private const int ToolTargetDestroyed = 0x100;
		private const int InInitialize = 0x200;
		private const int FormClosingHooked = 0x400;
		private const int FlagDisplayAsIcon = 0x800;
		private const int OwnObject = 0x1000;
		private const int OleInitCalled = 0x2000;
		private const int OleObjectInit = 0x4000;
		private const int ReactivateObject = 0x8000;
		#endregion

		#region 构造函数
		public ActiveDocumentHost()
		{
			this.borderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.activationGesture = ActivationGesture.DoubleClick;
			this.statusText = "";
			base.SetStyle(ControlStyles.ResizeRedraw | ControlStyles.ContainerControl, true);
			base.SetStyle(ControlStyles.Selectable, false);
			this.SetFlag(12, true);
			this.BackColor = SystemColors.Window;
		}

		private void InitializeComponent()
		{
			this.SuspendLayout();
			this.ResumeLayout(false);
		}

		public ActiveDocumentHost(System.Guid guid)
			: this()
		{
			this.Guid = guid;
		}

		public ActiveDocumentHost(string documentClassName)
			: this()
		{
			this.DocumentClassName = documentClassName;
		}

		#endregion

		#region 父控件 属性 重写


		public override Color BackColor
		{
			get
			{
				return base.BackColor;
			}
			set
			{
				base.BackColor = value;
			}
		}

		[Browsable(false), DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
		public override System.Windows.Forms.RightToLeft RightToLeft
		{
			get
			{
				return base.RightToLeft;
			}
			set
			{
				base.RightToLeft = value;
			}
		}



		[Browsable(false), EditorBrowsable(EditorBrowsableState.Never), Bindable(false), DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
		public override string Text
		{
			get
			{
				return base.Text;
			}
			set
			{
				base.Text = value;
			}
		}

		[Browsable(false), DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
		public override System.Drawing.Font Font
		{
			get
			{
				return base.Font;
			}
			set
			{
				base.Font = value;
			}
		}

		[Browsable(false), DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
		public override Color ForeColor
		{
			get
			{
				return base.ForeColor;
			}
			set
			{
				base.ForeColor = value;
			}
		}

		[Browsable(false), DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
		public override Image BackgroundImage
		{
			get
			{
				return base.BackgroundImage;
			}
			set
			{
				base.BackgroundImage = value;
			}
		}

		[Browsable(false), DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
		public override ImageLayout BackgroundImageLayout
		{
			get
			{
				return base.BackgroundImageLayout;
			}
			set
			{
				base.BackgroundImageLayout = value;
			}
		}

		#endregion

		#region 父控件 事件 重写

		[DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden), Browsable(false)]
		public new event EventHandler BackgroundImageChanged
		{
			add
			{
				base.BackgroundImageChanged += value;
			}
			remove
			{
				base.BackgroundImageChanged -= value;
			}
		}

		[DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden), Browsable(false)]
		public new event EventHandler BackgroundImageLayoutChanged
		{
			add
			{
				base.BackgroundImageLayoutChanged += value;
			}
			remove
			{
				base.BackgroundImageLayoutChanged -= value;
			}
		}
		[DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden), Browsable(false)]
		public new event EventHandler FontChanged
		{
			add
			{
				base.FontChanged += value;
			}
			remove
			{
				base.FontChanged -= value;
			}
		}

		[DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden), Browsable(false)]
		public new event EventHandler RightToLeftChanged
		{
			add
			{
				base.RightToLeftChanged += value;
			}
			remove
			{
				base.RightToLeftChanged -= value;
			}
		}

		[DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden), EditorBrowsable(EditorBrowsableState.Never), Browsable(false)]
		public new event EventHandler TextChanged
		{
			add
			{
				base.TextChanged += value;
			}
			remove
			{
				base.TextChanged -= value;
			}
		}
		[Browsable(false)]
		public new event PaintEventHandler Paint
		{
			add
			{
				base.Paint += value;
			}
			remove
			{
				base.Paint -= value;
			}
		}

		[Browsable(false), DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
		public new event EventHandler ForeColorChanged
		{
			add
			{
				base.ForeColorChanged += value;
			}
			remove
			{
				base.ForeColorChanged -= value;
			}
		}

		#endregion

		#region 父控件 函数 重写
		protected override void OnHandleCreated(EventArgs e)
		{
			base.OnHandleCreated(e);
			if (!this.GetFlag(OleObjectInit))
			{
				this.InitializeOleObject();
			}
			else if (this.GetFlag(ReactivateObject))
			{
				Application.Idle += new EventHandler(this.OnIdle);
			}
			if (!this.GetFlag(FormClosingHooked))
			{
				Form form = base.FindForm();
				if (form != null)
				{
					form.Closing += new CancelEventHandler(this.OnFormClosing);
				}
				this.SetFlag(FormClosingHooked, true);
			}
		}

		protected override void OnHandleDestroyed(EventArgs e)
		{
			bool flag = this.ActivationState == ActivationState.Active;
			this.SetFlag(ReactivateObject, flag);
			if (flag)
			{
				this.Deactivate();
			}
			if (this.GetFlag(FormClosingHooked))
			{
				Form form = base.FindForm();
				if (form != null)
				{
					form.Closing -= new CancelEventHandler(this.OnFormClosing);
				}
				this.SetFlag(FormClosingHooked, false);
			}
			base.OnHandleDestroyed(e);
		}

		protected override void OnLeave(EventArgs e)
		{
			this.Deactivate();
			base.OnLeave(e);
		}

		protected override void OnPaint(PaintEventArgs e)
		{
			switch (this.BorderStyle)
			{
				case System.Windows.Forms.BorderStyle.FixedSingle:
					ControlPaint.DrawBorder(e.Graphics, base.ClientRectangle, this.ForeColor, ButtonBorderStyle.Solid);
					break;

				case System.Windows.Forms.BorderStyle.Fixed3D:
					ControlPaint.DrawBorder3D(e.Graphics, base.ClientRectangle);
					break;
			}
			base.OnPaint(e);
		}


		protected override void OnSizeChanged(EventArgs e)
		{
			if (this.adsite != null)
			{
				this.adsite.UpdateClientRect(true, Rectangle.Empty);
			}
			base.OnSizeChanged(e);
		}

		protected override void Dispose(bool disposing)
		{
			if (disposing)
			{
				this.DestroyOleObject();
				if (this.GetFlag(OleInitCalled))
				{
					UnsafeNativeMethods.OleUninitialize();
					this.SetFlag(OleInitCalled, false);
				}
			}
			this.ToolTarget = null;
			base.Dispose(disposing);
		}

		/*
		[StrongNameIdentityPermission(SecurityAction.InheritanceDemand, Name="System.Windows.Forms", PublicKey="0x00000000000000000400000000000000")]
		internal override Size GetPreferredSizeCore(Size proposedSize)
		{
			if (((this.OleObject != null) && base.IsHandleCreated) && ((this.adsite != null) && (this.ActivationState != ActivationState.Active)))
			{
				Size preferredSize = this.adsite.PreferredSize;
				if (preferredSize != Size.Empty)
				{
					return preferredSize;
				}
			}
			return base.GetPreferredSizeCore(proposedSize);
		}
		*/

		/*
		internal override bool ShouldSerializeBackColor()
		{
			return (this.BackColor != SystemColors.Window);
		}
		*/

		#endregion

		#region 属性


		private ActiveDocumentContainer AdContainer
		{
			get
			{
				return this.adcontainer;
			}
		}

		private ActiveDocumentSite AdSite
		{
			get
			{
				return this.adsite;
			}
		}

		private UnsafeNativeMethods.IOleObject OleObject
		{
			get
			{
				return this.pOleObject;
			}
		}

		[Category("CatAppearance")]
		[TypeConverter(typeof(ToolTargetConverter))]
		[Description("工具栏对象")]
		public ScrollableControl ToolTarget
		{
			get
			{
				if (this.toolTarget != null)
				{
					return this.toolTarget;
				}
				return this;
			}
			set
			{
				if (value != this.toolTarget)
				{
					if (value == this)
					{
						value = null;
					}
					ScrollableControl control = value;
					if (value == null)
					{
						control = this;
					}
					bool flag = this.ActivationState == ActivationState.Active;
					if (flag)
					{
						this.Deactivate();
					}
					if (!base.DesignMode)
					{
						this.ToolTarget.HandleDestroyed -= new EventHandler(this.ToolTarget_HandleDestroyed);
						this.ToolTarget.HandleCreated -= new EventHandler(this.ToolTarget_HandleCreated);
						this.ToolTarget.Resize -= new EventHandler(this.ToolTarget_Resize);
					}
					this.SetFlag(ToolTargetDestroyed, false);
					this.toolTarget = value;
					if (!base.DesignMode)
					{
						control.HandleDestroyed += new EventHandler(this.ToolTarget_HandleDestroyed);
						control.HandleCreated += new EventHandler(this.ToolTarget_HandleCreated);
						control.Resize += new EventHandler(this.ToolTarget_Resize);
					}
					if ((this.adsite != null) && base.Visible)
					{
						this.adsite.UpdateClientRect(true, Rectangle.Empty);
					}
					if (control.Visible)
					{
						control.PerformLayout();
					}
					if (flag)
					{
						this.Activate();
					}
				}
			}
		}

		[DefaultValue(ActivationGesture.DoubleClick)]
		[Category("CatBehavior")]
		[Description("激活行为")]
		public ActivationGesture ActivationGesture
		{
			get
			{
				return this.activationGesture;
			}
			set
			{
				if (!Enum.IsDefined(typeof(ActivationGesture), value))
				{
					throw new InvalidEnumArgumentException("value", (int)value, typeof(ActivationGesture));
				}
				this.activationGesture = value;
			}
		}

		[DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
		[Description("活动文档类型")]
		public string ActiveDocumentType
		{
			get
			{
				if (this.OleObject != null)
				{
					string userType = null;
					if (NativeMethods.Succeeded(this.OleObject.GetUserType(3, out userType)))
					{
						return userType;
					}
				}
				return "";
			}
		}

		[Category("CatAppearance")]
		[DefaultValue(false)]
		[Description("活动文档显示为图标")]
		internal bool DisplayAsIcon
		{
			get
			{
				return this.GetFlag(FlagDisplayAsIcon);
			}
			set
			{
				if (value != this.GetFlag(FlagDisplayAsIcon))
				{
					this.SetFlag(FlagDisplayAsIcon, value);
					base.Invalidate(true);
				}
			}
		}

		[Category("CatAppearance")]
		[Editor("System.Windows.Forms.Design.FileNameEditor, System.Design, Version=2.0.3600.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a", typeof(UITypeEditor))]
		[RefreshProperties(RefreshProperties.Repaint)]
		[Description("源文档")]
		public string SourceDocument
		{
			get
			{
				return this.sourceDoc;
			}
			set
			{
				if ((value != this.sourceDoc) || this.IsDocumentDataDirty)
				{
					this.DestroyOleObject();
					if ((value != null) && (value.Length > 0))
					{
						this.LoadFrom(value);
					}
					else
					{
						this.sourceDoc = null;
						this.SetFlag(SourceDocSet, false);
					}
				}
			}
		}

		[Category("CatAppearance")]
		[RefreshProperties(RefreshProperties.Repaint)]
		[Editor("System.Windows.Forms.Design.ActiveDocumentTypeEditor, System.Design, Version=2.0.3600.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a", typeof(UITypeEditor))]
		[Description("活动文档 ProgId")]
		public string DocumentClassName
		{
			get
			{
				if ((this.progId == null) && (this.guid != System.Guid.Empty))
				{
					this.progId = this.GetProgIdFromGuid(this.guid);
				}
				return this.progId;
			}
			set
			{
				if ((value != this.progId) || this.IsDocumentDataDirty)
				{
					bool flag = this.ActivationState == ActivationState.Active;
					string progId = null;
					if (this.ShouldSerializeDocumentClassName())
					{
						progId = this.progId;
					}
					if (this.OleObject != null)
					{
						this.DestroyOleObject();
					}
					if ((value != null) && (value.Length > 0))
					{
						this.guid = this.GetGuidFromProgId(value);
						if (!this.IsValidDocObject(this.guid, false))
						{
							throw new ArgumentException(SR.GetString("ActiveDocumentHostInvalidProgId", new object[] { value }));
						}
						this.sourceDoc = null;
						this.progId = value;
						this.SetFlag(GuidSet, false);
						this.SetFlag(ProgIdSet, true);
						this.SetFlag(SourceDocSet, false);
						if (base.IsHandleCreated)
						{
							try
							{
								this.InitializeOleObject();
							}
							catch
							{
								this.progId = progId;
								this.SetFlag(ProgIdSet, progId != null);
								throw;
							}
							if (flag)
							{
								this.Activate();
							}
						}
					}
					else
					{
						this.progId = null;
						this.SetFlag(ProgIdSet, false);
					}
				}
			}
		}

		[Category("CatAppearance")]
		[RefreshProperties(RefreshProperties.Repaint)]
		[Description("活动文档类别 Guid")]
		[Browsable(false)]
		public System.Guid Guid
		{
			get
			{
				if ((this.guid == System.Guid.Empty) && (this.progId != null))
				{
					this.guid = this.GetGuidFromProgId(this.progId);
				}
				return this.guid;
			}
			set
			{
				if ((value != this.guid) || this.IsDocumentDataDirty)
				{
					if (value != System.Guid.Empty)
					{
						this.IsValidDocObject(value, true);
					}
					System.Guid empty = System.Guid.Empty;
					if (this.ShouldSerializeGuid())
					{
						empty = this.guid;
					}
					bool flag = this.ActivationState == ActivationState.Active;
					if (this.OleObject != null)
					{
						this.DestroyOleObject();
					}
					if (value != System.Guid.Empty)
					{
						this.progId = this.GetProgIdFromGuid(value);
						this.guid = value;
						this.sourceDoc = null;
						this.SetFlag(SourceDocSet, false);
						this.SetFlag(GuidSet, true);
						this.SetFlag(ProgIdSet, false);
						if (base.IsHandleCreated)
						{
							try
							{
								this.InitializeOleObject();
							}
							catch
							{
								this.guid = empty;
								this.SetFlag(GuidSet, this.guid != System.Guid.Empty);
								throw;
							}
							if (flag)
							{
								this.Activate();
							}
						}
					}
					else
					{
						this.guid = value;
						this.SetFlag(GuidSet, false);
					}
				}
			}
		}

		[Category("CatAppearance")]
		[Description("显示菜单栏")]
		[DefaultValue(true)]
		public bool ShowMenus
		{
			get
			{
				return this.GetFlag(FlagShowMenus);
			}
			set
			{
				if (this.ShowMenus != value)
				{
					this.SetFlag(FlagShowMenus, value);
					if (this.ActivationState == ActivationState.Active)
					{
						this.Deactivate();
						this.Activate();
					}
				}
			}
		}

		[Category("CatAppearance")]
		[Description("显示工具栏")]
		[DefaultValue(true)]
		public bool ShowToolbars
		{
			get
			{
				return this.GetFlag(FlagShowToolbars);
			}
			set
			{
				if (this.ShowToolbars != value)
				{
					this.SetFlag(FlagShowToolbars, value);
					if (this.ActivationState == ActivationState.Active)
					{
						this.Deactivate();
						this.Activate();
					}
				}
			}
		}

		[Category("CatAppearance")]
		[Description("缩放模式")]
		[DefaultValue(DocumentSizeMode.Clip)]
		public DocumentSizeMode SizeMode
		{
			get
			{
				return this.sizeMode;
			}
			set
			{
				if (!Enum.IsDefined(typeof(DocumentSizeMode), value))
				{
					throw new InvalidEnumArgumentException("value", (int)value, typeof(DocumentSizeMode));
				}
				if (value != this.sizeMode)
				{
					this.sizeMode = value;
					if (this.OleObject != null)
					{
						this.AdSite.OnSizeModeChanged(this, EventArgs.Empty);
					}
				}
			}
		}


		[Browsable(false)]
		public bool IsDocumentDataDirty
		{
			get
			{
				return ((this.adsite != null) && this.adsite.DataChanged);
			}
		}


		[Browsable(false)]
		[DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
		public ActivationState ActivationState
		{
			get
			{
				if ((base.Visible && base.IsHandleCreated) && (this.OleObject != null))
				{
					return this.activationState;
				}
				return ActivationState.None;
			}
		}


		[DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
		[Browsable(false)]
		public object Document
		{
			get
			{
				return this.OleObject;
			}
		}

		[Browsable(false)]
		public Stream SourceData
		{
			get
			{
				return this.SaveStateToStream(null);
			}
			set
			{
				bool HaveOleObject = this.OleObject != null;
				bool IsActive = this.ActivationState == ActivationState.Active;
				if (HaveOleObject)
				{
					this.DestroyOleObject();
				}
				this.SetFlag(SourceDataSet, value != null);
				this.SetFlag(3, false);
				if (value != null)
				{
					if (!this.GetFlag(InInitialize))
					{
						this.SetFlag(SourceDocSet, false);
						this.sourceDoc = null;
					}
					this.storage = this.StreamToIStorage(value);
					if (HaveOleObject || base.IsHandleCreated)
					{
						this.InitializeOleObject();
						if (IsActive)
						{
							this.Activate();
						}
					}
				}
			}
		}

		[DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
		[Browsable(false)]
		public string StatusText
		{
			get
			{
				return this.statusText;
			}
		}

		private UnsafeNativeMethods.IStorage Storage
		{
			get
			{
				return this.storage;
			}
		}

		#endregion

		#region 事件
		[Category("CatBehavior")]
        [Description("活动文档激活")]
        public event EventHandler Activated
        {
            add
            {
                base.Events[EventActivated] = Delegate.Combine(base.Events[EventActivated], value);
            }
            remove
            {
                base.Events[EventActivated] = Delegate.Remove(base.Events[EventActivated], value);
            }
        }

        [Category("CatBehavior")]
		[Description("活动文档冻结")]
        public event EventHandler Deactivated
        {
            add
            {
                base.Events[EventDeactivated] = Delegate.Combine(base.Events[EventDeactivated], value);
            }
            remove
            {
                base.Events[EventDeactivated] = Delegate.Remove(base.Events[EventDeactivated], value);
            }
        }

        [Category("CatBehavior")]
		[Description("活动文档修改")]
        public event EventHandler DocumentModified
        {
            add
            {
                base.Events[EventDocumentModified] = Delegate.Combine(base.Events[EventDocumentModified], value);
            }
            remove
            {
                base.Events[EventDocumentModified] = Delegate.Remove(base.Events[EventDocumentModified], value);
            }
        }


		[Category("CatBehavior")]
		[Description("活动文档加载完毕")]
        public event EventHandler Loaded
        {
            add
            {
                base.Events[EventLoaded] = Delegate.Combine(base.Events[EventLoaded], value);
            }
            remove
            {
                base.Events[EventLoaded] = Delegate.Remove(base.Events[EventLoaded], value);
            }
        }

        
		[Category("CatBehavior")]
		[Description("活动文档保存完毕")]
        public event EventHandler Saved
        {
            add
            {
                base.Events[EventSaved] = Delegate.Combine(base.Events[EventSaved], value);
            }
            remove
            {
                base.Events[EventSaved] = Delegate.Remove(base.Events[EventSaved], value);
            }
        }

        
		[Category("CatBehavior")]
		[Description("活动文档状态文本改变")]
        public event EventHandler StatusTextChanged
        {
            add
            {
                base.Events[EventStatusTextChanged] = Delegate.Combine(base.Events[EventStatusTextChanged], value);
            }
            remove
            {
                base.Events[EventStatusTextChanged] = Delegate.Remove(base.Events[EventStatusTextChanged], value);
            }
        }



		#endregion

		#region 函数

		[EditorBrowsable(EditorBrowsableState.Advanced)]
		protected virtual ActiveDocumentContainer CreateHostClass()
		{
			return new ActiveDocumentContainer(this);
		}

		[EditorBrowsable(EditorBrowsableState.Advanced)]
		protected virtual ActiveDocumentSite CreateSiteClass()
		{
			return new ActiveDocumentSite(this);
		}

		/// <summary>
		/// 初始化OleBoject 由 OnHandleCreated 自动调用
		/// </summary>
		private void InitializeOleObject()
		{
			Cursor current = Cursor.Current;
			try
			{
				Cursor.Current = Cursors.WaitCursor;
				if (
						(!this.GetFlag(OleObjectInit) && !this.GetFlag(InInitialize)) &&
						(
							(this.GetFlag(GuidSet) || this.GetFlag(ProgIdSet)) ||
							(
								((this.sourceDoc != null) || (this.storage != null)) || (this.OleObject != null)
							)
						)
					)
				{
					if (!this.GetFlag(OleInitCalled))
					{
						UnsafeNativeMethods.OleInitialize();
						this.SetFlag(OleInitCalled, true);
					}
					if (this.OleObject == null)
					{
						if ((!this.GetFlag(SourceDataSet) && (this.sourceDoc != null)) && (this.sourceDoc.Length > 0))
						{
							this.pOleObject = this.CreateOleObjectFromFile(this.sourceDoc);
						}
						else if (this.GetFlag(ProgIdSet) && (this.progId != null))
						{
							this.pOleObject = this.CreateOleObject(this.progId);
						}
						else if (((this.storage != null) && this.GetFlag(SourceDataSet)) || (this.GetFlag(GuidSet) && (this.guid != System.Guid.Empty)))
						{
							this.pOleObject = this.CreateOleObject(this.guid, this.storage);
						}
					}
					if (this.OleObject != null)
					{
						if (this.adsite == null)
						{
							this.adsite = this.CreateSiteClass();
						}
						if (this.adcontainer == null)
						{
							this.adcontainer = this.CreateHostClass();
						}
						this.OleObject.SetClientSite(this.adsite);
						UnsafeNativeMethods.OleRun(this.OleObject);
						this.SetFlag(OleObjectInit, true);
						this.activationState = ActivationState.Inactive;
						this.OnLoaded(EventArgs.Empty);
					}
				}
			}
			finally
			{
				Cursor.Current = current;
			}
		}

		/// <summary>
		/// 控件激活
		/// </summary>
		public void Activate()
        {
            if ((((this.OleObject != null) && base.IsHandleCreated) && (this.adsite != null)) && ((this.ActivationState == ActivationState.Inactive) || (this.ActivationState == ActivationState.Active)))
            {
                this.adsite.UIActivate();
            }
        }

		/// <summary>
		/// 控件冻结
		/// </summary>
		public void Deactivate()
		{
			if (((this.OleObject != null) && base.IsHandleCreated) && ((this.adsite != null) && (this.ActivationState == ActivationState.Active)))
			{
				this.adsite.Deactivate();
			}
		}

        private UnsafeNativeMethods.IOleObject CreateOleObject(string progId)
        {
            if (this.guid == System.Guid.Empty)
            {
                this.guid = this.GetGuidFromProgId(progId);
                if (this.guid == System.Guid.Empty)
                {
                    throw new ArgumentException(SR.GetString("ActiveDocumentHostBadProgId", new object[] { progId }));
                }
                if (!this.IsValidDocObject(this.guid, false))
                {
                    throw new ArgumentException(SR.GetString("ActiveDocumentHostInvalidProgId", new object[] { progId }));
                }
            }
            return this.CreateOleObject(this.guid, null);
        }

        private UnsafeNativeMethods.IOleObject CreateOleObject(System.Guid OleObjectGuid, UnsafeNativeMethods.IStorage storage)
        {
            if (this.OleObject == null)
            {
                System.Guid IID_IOleObject = typeof(UnsafeNativeMethods.IOleObject).GUID;
                int hr = 0;
                if (storage == null)
                {
                    this.IsValidDocObject(OleObjectGuid, true);
                    hr = UnsafeNativeMethods.OleCreate(ref OleObjectGuid, ref IID_IOleObject, NativeMethods.OLERENDER.OLERENDER_DRAW, null, null, this.CreateStorage(OleObjectGuid), out this.pOleObject);
                }
                else
                {
                    hr = UnsafeNativeMethods.OleLoad(storage, ref IID_IOleObject, null, out this.pOleObject);
                }
                if (this.OleObject == null)
                {
                    if (storage != null)
                    {
                        System.Guid guid2;
                        if (NativeMethods.Succeeded(UnsafeNativeMethods.OleDoAutoConvert(storage, out guid2)))
                        {
                            OleObjectGuid = guid2;
                        }
                    }
                    else
                    {
                        System.Guid guid3;
                        if (NativeMethods.Succeeded(UnsafeNativeMethods.OleGetAutoConvert(ref OleObjectGuid, out guid3)))
                        {
                            OleObjectGuid = guid3;
                        }
                    }
                    if (OleObjectGuid != System.Guid.Empty)
                    {
                        this.IsValidDocObject(OleObjectGuid, true);
                        try
                        {
                            object obj2 = UnsafeNativeMethods.CoCreateInstance(ref OleObjectGuid, null, 5, ref IID_IOleObject);
                            this.pOleObject = (UnsafeNativeMethods.IOleObject) obj2;
                        }
                        catch (ExternalException exception)
                        {
                            hr = exception.ErrorCode;
                        }
                    }
                }
                if (NativeMethods.Succeeded(hr) && (this.OleObject != null))
                {
					this.SetFlag(OwnObject, true);
                    this.guid = System.Guid.Empty;
                    this.progId = null;
					this.SetFlag(GuidSet, false);
					this.SetFlag(ProgIdSet, false);
                    NativeMethods.Succeeded(this.OleObject.GetUserClassID(ref this.guid));
                }
                if (this.OleObject == null)
                {
                    throw new ExternalException(SR.GetString("ActiveDocumentHostCantCreate"), hr);
                }
            }
            return this.OleObject;
        }

		/// <summary>
		/// 从文件建立OleObject
		/// </summary>
		/// <param name="fileName"></param>
		/// <returns></returns>
        private UnsafeNativeMethods.IOleObject CreateOleObjectFromFile(string fileName)
        {
            if (this.OleObject == null)
            {
                System.Guid iID_IUnknown = NativeMethods.ActiveX.IID_IUnknown;
				Guid empty = Guid.Empty;
				if (NativeMethods.Succeeded(UnsafeNativeMethods.OleCreateFromFile
					(
						ref empty, fileName, ref iID_IUnknown, NativeMethods.OLERENDER.OLERENDER_DRAW, null, null, this.CreateStorage(System.Guid.Empty), out this.pOleObject
					)) 
					&& (this.OleObject != null))
                {
                    this.guid = System.Guid.Empty;
                    this.progId = null;
                    this.sourceDoc = fileName;
                    this.SetFlag(0x23, false);
					this.SetFlag(OwnObject, true);
                    NativeMethods.Succeeded(this.OleObject.GetUserClassID(ref this.guid));
                }
            }
            return this.OleObject;
        }

		/// <summary>
		/// 建立存储
		/// </summary>
		/// <param name="initGuid"></param>
		/// <returns></returns>
        private UnsafeNativeMethods.IStorage CreateStorage(System.Guid initGuid)
        {
            if (this.storage == null)
            {
                UnsafeNativeMethods.ILockBytes iLockBytes = UnsafeNativeMethods.CreateILockBytesOnHGlobal(new HandleRef(this, IntPtr.Zero), true);
                this.storage = UnsafeNativeMethods.StgCreateDocfileOnILockBytes(iLockBytes, 0x1012, 0);
                if (initGuid != System.Guid.Empty)
                {
                    UnsafeNativeMethods.WriteClassStg(this.storage, ref initGuid);
                }
            }
            return this.storage;
        }

		/// <summary>
		/// 销毁OleObject对象
		/// </summary>
        private void DestroyOleObject()
        {
			//保存当前鼠标状态
            Cursor current = Cursor.Current;
            try
            {
				//鼠标状态设为繁忙
                Cursor.Current = Cursors.WaitCursor;
                if (this.OleObject != null)
                {
                    try
                    {
						//冻结
                        this.Deactivate();
                    }
                    finally
                    {
                        this.statusText = "";
						this.SetFlag(OleObjectInit, false);
						this.SetFlag(ReactivateObject, false);
                        this.activationState = ActivationState.None;
                        if (this.adsite != null)
                        {
                            this.adsite.Dispose();
                            this.adsite = null;
                        }
                        if (this.adcontainer != null)
                        {
                            this.adcontainer.Dispose();
                            this.adcontainer = null;
                        }
                    }
					if (this.GetFlag(OwnObject))
                    {
                        try
                        {
							//释放Com对象
                            Marshal.ReleaseComObject(this.OleObject);
                        }
                        catch
                        {
                        }
						this.SetFlag(OwnObject, false);
                    }
                    this.pOleObject = null;
                    if (this.storage != null)
                    {
						//释放com对象
                        Marshal.ReleaseComObject(this.storage);
                        this.storage = null;
                    }
                }
                GC.Collect();
            }
            finally
            {
                Cursor.Current = current;
            }
        }

		/// <summary>
		/// 获取标记
		/// </summary>
		/// <param name="flag"></param>
		/// <returns></returns>
        private bool GetFlag(int flag)
        {
            return ((this.flags & flag) == flag);
        }

		/// <summary>
		/// 设置标记
		/// </summary>
		/// <param name="flag"></param>
		/// <param name="value"></param>
		private void SetFlag(int flag, bool value)
		{
			if (value)
			{
				this.flags |= flag;
			}
			else
			{
				this.flags &= ~flag;
			}
		}

		/// <summary>
		/// 从ProgId获取GUID
		/// </summary>
		/// <param name="progId"></param>
		/// <returns></returns>
        private System.Guid GetGuidFromProgId(string progId)
        {
            RegistryKey progId_key2 = Registry.ClassesRoot.OpenSubKey(progId);
            if (progId_key2 != null)
            {
                try
                {
                    RegistryKey CLSID_key3 = progId_key2.OpenSubKey("CLSID");
                    if (CLSID_key3 != null)
                    {
                        try
                        {
                            return new System.Guid((string) CLSID_key3.GetValue(null));
                        }
                        finally
                        {
                            CLSID_key3.Close();
                        }
                    }
                }
                finally
                {
                    progId_key2.Close();
                }
            }
            return System.Guid.Empty;
        }

		/// <summary>
		/// 从GUID获取ProgId
		/// </summary>
		/// <param name="guidobject"></param>
		/// <returns></returns>
        private string GetProgIdFromGuid(System.Guid guidobject)
        {
            RegistryKey key2 = Registry.ClassesRoot.OpenSubKey("CLSID");
            try
            {
                RegistryKey clsid_key = key2.OpenSubKey("{" + guidobject.ToString() + "}");
                if (clsid_key != null)
                {
                    try
                    {
                        RegistryKey ProgID_key = clsid_key.OpenSubKey("ProgID");
                        if (ProgID_key != null)
                        {
                            try
                            {
                                return (string) ProgID_key.GetValue(null);
                            }
                            finally
                            {
                                ProgID_key.Close();
                            }
                        }
                    }
                    finally
                    {
                        clsid_key.Close();
                    }
                }
            }
            finally
            {
                key2.Close();
            }
            return null;
        }

		/// <summary>
		/// 是否是有效的文档对象
		/// </summary>
		/// <param name="DocObjectguid"></param>
		/// <param name="throwIfFalse"></param>
		/// <returns></returns>
        private bool IsValidDocObject(System.Guid DocObjectguid, bool throwIfFalse)
        {
            RegistryKey clsids = Registry.ClassesRoot.OpenSubKey("CLSID");
            try
            {
                RegistryKey docguid = clsids.OpenSubKey("{" + DocObjectguid.ToString() + "}");
                try
                {
                    if (docguid != null)
                    {
                        RegistryKey key3 = docguid.OpenSubKey("Insertable");//可插入
                        RegistryKey key4 = docguid.OpenSubKey("NotInsertable");//不可插入
                        RegistryKey key5 = docguid.OpenSubKey("Control");//控件
                        try
                        {
                            if (((key3 != null) && (key4 == null)) && (key5 == null))
                            {
                                return true;
                            }
                        }
                        finally
                        {
                            if (key3 != null)
                            {
                                key3.Close();
                            }
                            if (key4 != null)
                            {
                                key4.Close();
                            }
                            if (key5 != null)
                            {
                                key5.Close();
                            }
                        }
                    }
                }
                finally
                {
                    if (docguid != null)
                    {
                        docguid.Close();
                    }
                }
            }
            finally
            {
                clsids.Close();
            }
            if (throwIfFalse)
            {
                throw new ArgumentException(SR.GetString("ActiveDocumentHostInvalidGuid", new object[] { DocObjectguid.ToString() }));
            }
            return false;
        }

		/// <summary>
		/// 从文件加载
		/// </summary>
		/// <param name="fileName"></param>
        public void LoadFrom(string fileName)
        {
            if (!File.Exists(fileName))
            {
                throw new FileNotFoundException(SR.GetString("FileDialogFileNotFound", new object[] { fileName }));
            }
			this.SetFlag(SourceDocSet, true);
			this.SetFlag(GuidSet | ProgIdSet, false);
            this.sourceDoc = fileName;
            try
            {
				if (!this.GetFlag(InInitialize))
                {
					this.SetFlag(SourceDataSet, false);
                    if (base.IsHandleCreated)
                    {
                        bool flag = this.ActivationState == ActivationState.Active;
                        this.DestroyOleObject();
                        this.InitializeOleObject();
                        if (flag)
                        {
                            this.Activate();
                        }
                    }
                }
            }
            catch
            {
				this.SetFlag(SourceDocSet, false);
                this.sourceDoc = null;
                throw;
            }
        }

		/// <summary>
		/// 关闭文档
		/// </summary>
		public void CloseDocument()
		{
			this.DestroyOleObject();
		}

		/// <summary>
		/// 窗体关闭执行冻结
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void OnFormClosing(object sender, CancelEventArgs e)
        {
            this.Deactivate();
        }

		/// <summary>
		/// 空闲时
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
        private void OnIdle(object sender, EventArgs e)
        {
            Application.Idle -= new EventHandler(this.OnIdle);
			if (this.GetFlag(ReactivateObject))
            {
				this.SetFlag(ReactivateObject, false);
                this.Activate();
            }
        }

		/// <summary>
		/// 重设文档类
		/// </summary>
        private void ResetDocumentClassName()
        {
            if (this.ShouldSerializeDocumentClassName())
            {
                this.DocumentClassName = null;
            }
        }

		/// <summary>
		/// 重设GUID
		/// </summary>
        private void ResetGuid()
        {
            if (this.ShouldSerializeGuid())
            {
                this.Guid = System.Guid.Empty;
            }
        }

		/// <summary>
		/// 重设源文档
		/// </summary>
        private void ResetSourceDocument()
        {
            if (this.ShouldSerializeSourceDocument())
            {
                this.SourceDocument = null;
            }
        }

		/// <summary>
		/// 重设工具栏目标
		/// </summary>
        private void ResetToolTarget()
        {
            this.ToolTarget = null;
        }

		/// <summary>
		/// 保存状态到流
		/// </summary>
		/// <param name="stream"></param>
		/// <returns></returns>
        private Stream SaveStateToStream(Stream stream)
        {
            Stream stream2;
            if (this.OleObject == null)
            {
                return null;
            }
            Cursor current = Cursor.Current;
            try
            {
                Cursor.Current = Cursors.WaitCursor;
                stream2 = this.StreamFromIStorage(this.storage, stream);
            }
            finally
            {
                Cursor.Current = current;
            }
            return stream2;
        }

		/// <summary>
		/// 存储转流
		/// </summary>
		/// <param name="storage"></param>
		/// <param name="stream"></param>
		/// <returns></returns>
		private Stream StreamFromIStorage(UnsafeNativeMethods.IStorage storage, Stream stream)
		{
			if (storage == null)
			{
				return null;
			}
			UnsafeNativeMethods.ILockBytes lockBytes = UnsafeNativeMethods.CreateILockBytesOnHGlobal(new HandleRef(this, IntPtr.Zero), true);
			UnsafeNativeMethods.IStorage storage2 = null;
			Cursor current = Cursor.Current;
			try
			{
				Cursor.Current = Cursors.WaitCursor;
				storage2 = UnsafeNativeMethods.StgCreateDocfileOnILockBytes(lockBytes, 4114, 0);
				UnsafeNativeMethods.IPersistStorage pPersistStorage = (UnsafeNativeMethods.IPersistStorage)this.OleObject;
				int num = UnsafeNativeMethods.OleSave(pPersistStorage, storage2, false);
				IntPtr hGlobalFromILockBytes = UnsafeNativeMethods.GetHGlobalFromILockBytes(lockBytes);
				int num2 = UnsafeNativeMethods.GlobalSize(new HandleRef(this, hGlobalFromILockBytes));
				IntPtr intPtr = UnsafeNativeMethods.GlobalLock(new HandleRef(this, hGlobalFromILockBytes));
				if (intPtr != IntPtr.Zero)
				{
					try
					{
						byte[] array = new byte[num2];
						Marshal.Copy(intPtr, array, 0, array.Length);
						if (stream == null)
						{
							stream = new MemoryStream(array);
						}
						else
						{
							stream.Write(array, 0, num2);
						}
					}
					finally
					{
						UnsafeNativeMethods.GlobalUnlock(new HandleRef(this, hGlobalFromILockBytes));
					}
				}
			}
			finally
			{
				Marshal.ReleaseComObject(storage2);
				Marshal.ReleaseComObject(lockBytes);
				Cursor.Current = current;
			}
			return stream;
		}

		/// <summary>
		/// 流转存贮
		/// </summary>
		/// <param name="s"></param>
		/// <returns></returns>
		private UnsafeNativeMethods.IStorage StreamToIStorage(Stream s)
		{
			if (s == null)
			{
				return null;
			}
			byte[] buffer = new byte[s.Length];
			s.Read(buffer, 0, buffer.Length);
			IntPtr handle = UnsafeNativeMethods.GlobalAlloc(0x2002, buffer.Length);
			IntPtr destination = UnsafeNativeMethods.GlobalLock(new HandleRef(this, handle));
			try
			{
				Marshal.Copy(buffer, 0, destination, buffer.Length);
				byte[] buffer2 = new byte[buffer.Length];
				Marshal.Copy(destination, buffer2, 0, buffer2.Length);
			}
			finally
			{
				UnsafeNativeMethods.GlobalUnlock(new HandleRef(this, handle));
			}
			UnsafeNativeMethods.ILockBytes iLockBytes = UnsafeNativeMethods.CreateILockBytesOnHGlobal(new HandleRef(this, handle), true);
			if (iLockBytes == null)
			{
				UnsafeNativeMethods.GlobalFree(new HandleRef(this, handle));
				return null;
			}
			return UnsafeNativeMethods.StgOpenStorageOnILockBytes(iLockBytes, null, 0x12, 0, 0);
		}

		/// <summary>
		/// 保存到流
		/// </summary>
		/// <param name="stream"></param>
        public void SaveTo(Stream stream)
        {
            if (stream == null)
            {
                throw new ArgumentNullException("stream");
            }
            if (this.OleObject == null)
            {
                throw new InvalidOperationException(SR.GetString("ActiveDocumentHostNeedObjectToSave"));
            }
            this.SaveStateToStream(stream);
            if (this.adsite != null)
            {
                this.adsite.DataChanged = false;
            }
            this.OnSaved(EventArgs.Empty);
        }

		/// <summary>
		/// 保存到文件
		/// </summary>
		/// <param name="fileName"></param>
        public void SaveTo(string fileName)
        {
            if (this.storage != null)
            {
                if (this.OleObject == null)
                {
                    throw new InvalidOperationException("保存需要对象");
                }

				//  0x11012 = 0x10000| 0x1000 | 0x10 |  2   = NativeMethods.STGM_TRANSACTED | NativeMethods.STGM_CREATE | NativeMethods.STGM_SHARE_EXCLUSIVE | NativeMethods.STGM_READWRITE = 
                UnsafeNativeMethods.IStorage pStorage = null;
				int hr = UnsafeNativeMethods.StgCreateDocfile(fileName, NativeMethods.STGM_TRANSACTED | NativeMethods.STGM_CREATE | NativeMethods.STGM_SHARE_EXCLUSIVE | NativeMethods.STGM_READWRITE, 0, out pStorage);
                if (NativeMethods.Succeeded(hr) && (pStorage != null))
                {
                    UnsafeNativeMethods.OleSave((UnsafeNativeMethods.IPersistStorage) this.OleObject, pStorage, false);
                    Marshal.ReleaseComObject(pStorage);
                    pStorage = null;
                    this.adsite.DataChanged = false;
                    this.OnSaved(EventArgs.Empty);
                }
                else
                {

					switch (hr)
                    {
						case NativeMethods.STG_E_TOOMANYOPENFILES:
						case NativeMethods.STG_E_SHAREVIOLATION:
						case NativeMethods.STG_E_LOCKVIOLATION:
                            throw new IOException("文件正在使用中", hr);

						case NativeMethods.STG_E_ACCESSDENIED:
						case NativeMethods.STG_E_DISKISWRITEPROTECTED:
                            throw new UnauthorizedAccessException("访问被拒绝");

						case NativeMethods.STG_E_SEEKERROR:
						case NativeMethods.STG_E_WRITEFAULT:
						case NativeMethods.STG_E_READFAULT:
                            throw new IOException("未知文件系统错误", hr);

                        case -2147287014:
                        case -2147287013:
                        case -2147287012:
                        case -2147287009:
                            return;
                    }
                }
            }
        }

		/// <summary>
		/// 内部设置激活状态
		/// </summary>
		/// <param name="newState"></param>
        internal void SetActivationStateInternal(ActivationState newState)
        {
            if (newState != this.activationState)
            {
                this.activationState = newState;
                switch (newState)
                {
                    case ActivationState.Inactive:
                        this.OnDeactivated(EventArgs.Empty);
                        return;

                    case ActivationState.Active:
                        this.OnActivated(EventArgs.Empty);
                        return;
                }
            }
        }

		/// <summary>
		/// 内部设置状态文本
		/// </summary>
		/// <param name="text"></param>
        internal void SetStatusTextInternal(string text)
        {
            this.statusText = text;
            this.OnStatusTextChanged(EventArgs.Empty);
        }

		#region 应否序列化判断
		private bool ShouldSerializeDocumentClassName()
        {
            return ((this.DocumentClassName != null) && (this.DocumentClassName.Length > 0));
        }

        private bool ShouldSerializeGuid()
        {
			return (this.GetFlag(GuidSet) && (this.Guid != System.Guid.Empty));
        }

        private bool ShouldSerializeSourceData()
        {
            return ((this.sourceDoc != null) || ((this.storage != null) && this.IsDocumentDataDirty));
        }

        private bool ShouldSerializeSourceDocument()
        {
			return this.GetFlag(SourceDocSet);
        }

        private bool ShouldSerializeToolTarget()
        {
            return (this.ToolTarget != this);
        }
		#endregion

		private static bool VerifyCast(object comObject, Type t)
		{
			IntPtr iUnknownForObject = Marshal.GetIUnknownForObject(comObject);
			if (iUnknownForObject != IntPtr.Zero)
			{
				try
				{
					IntPtr ptr2;
					System.Guid gUID = t.GUID;
					if (NativeMethods.Succeeded(Marshal.QueryInterface(iUnknownForObject, ref gUID, out ptr2)))
					{
						Marshal.Release(ptr2);
					}
					else
					{
						return false;
					}
				}
				finally
				{
					Marshal.Release(iUnknownForObject);
				}
			}
			return true;
		}

		#endregion

		#region ToolTarget 事件

		private void ToolTarget_HandleCreated(object sender, EventArgs e)
        {
			if (this.GetFlag(ToolTargetDestroyed))
            {
				this.SetFlag(ToolTargetDestroyed, false);
                Application.Idle += new EventHandler(this.OnIdle);
            }
        }

        private void ToolTarget_HandleDestroyed(object sender, EventArgs e)
        {
            if (this.ActivationState == ActivationState.Active)
            {
                this.SetFlag(0x8100, true);
                this.Deactivate();
            }
        }

        private void ToolTarget_Resize(object sender, EventArgs e)
        {
            if (this.adcontainer != null)
            {
                this.adcontainer.UpdateBorders();
            }
        }

		#endregion

		#region 事件 处理 虚函数

		protected virtual void OnLoaded(EventArgs e)
		{
			if (base.Events[EventLoaded] != null)
			{
				((EventHandler)base.Events[EventLoaded])(this, e);
			}
		}



		protected virtual void OnSaved(EventArgs e)
		{
			if (base.Events[EventSaved] != null)
			{
				((EventHandler)base.Events[EventSaved])(this, e);
			}
		}


		protected virtual void OnStatusTextChanged(EventArgs e)
		{
			if (base.Events[EventStatusTextChanged] != null)
			{
				((EventHandler)base.Events[EventStatusTextChanged])(this, e);
			}
		}
		protected virtual void OnActivated(EventArgs e)
		{
			if (base.Events[EventActivated] != null)
			{
				((EventHandler)base.Events[EventActivated])(this, e);
			}
		}

		protected virtual void OnDeactivated(EventArgs e)
		{
			if (base.Events[EventDeactivated] != null)
			{
				((EventHandler)base.Events[EventDeactivated])(this, e);
			}
		}

		protected virtual void OnDocumentModified(EventArgs e)
		{
			if (base.Events[EventDocumentModified] != null)
			{
				((EventHandler)base.Events[EventDocumentModified])(this, e);
			}
		}
		#endregion


		[Category("CatAppearance")]
		[DefaultValue(1)]
		[Description("BorderStyle")]
		public System.Windows.Forms.BorderStyle BorderStyle
		{
			get
			{
				return this.borderStyle;
			}
			set
			{
				if (!Enum.IsDefined(typeof(System.Windows.Forms.BorderStyle), value))
				{
					throw new InvalidEnumArgumentException("value", (int)value, typeof(System.Windows.Forms.BorderStyle));
				}
				if (value != this.borderStyle)
				{
					this.borderStyle = value;
					base.Invalidate(true);
				}
			}
		}

		#region ISupportInitialize
		void ISupportInitialize.BeginInit()
		{
			this.SetFlag(InInitialize, true);
		}

		void ISupportInitialize.EndInit()
		{
			this.SetFlag(InInitialize, false);
			if (base.IsHandleCreated && (this.OleObject == null))
			{
				this.InitializeOleObject();
			}
		}

		#endregion

		#region ActiveDocumentContainer
		protected class ActiveDocumentContainer : 
			StandardOleMarshalObject, 
			IDisposable, 
			UnsafeNativeMethods.IOleInPlaceFrame, 
			/*第一个接口是IOleInPlaceFrame，这个接口是做为OLE包容器最高层框架窗口实现的一个接口，
			 * 用来在框架窗口中合并OLE对象的菜单、工具条，显示OLE对象状态，并可以向OLE包容传递键盘消息，
			 * 再由OLE包容向OLE对象传送，以实现某些热键。
			 * IOleInPlaceFrame同时继承了IOleInPlaceUIWindow接口，IOleInPlaceUIWindow接口又继承了IOleWindow接口，
			 * 因此实际上我们在实现这个接口时需要实现4个接口的方法（包含IUnknown）。
			 * 这些方法是：GetWindow、ContextSensitiveHelp、GetBorder、RequestBorderSpace、SetBorderSpace、   
			 * SetActiveObject、InsertMenus、SetMenu、RemoveMenus、SetStatusText、EnableModeless   、
			 * TranslateAccelerator（未包含IUnknown的三个方法）。
			 * 实现时同样不比完全实现，按照需要实现就可以了，
			 * 不实现的或者简单返回，或者返回未实现。
			 * 在本文后面的例子中，选择实现了
			 * ContextSensitiveHelp（安排OLE对象显示右键菜单）、
			 * GetBorder（安排OLE对象获得母窗口的边界）、
			 * SetBorderSpace（安排OLE对象的边界）、
			 * SetActiveObject（为母窗口记录下激活的OLE对象）、
			 * InsertMenus（合并菜单）、
			 * SetMenu   （设置菜单）、
			 * RemoveMenus（消除菜单）、
			 * TranslateAccelerator（向OLE对象传递热键）。 
			 */

			UnsafeNativeMethods.IOleInPlaceUIWindow, 
			UnsafeNativeMethods.IOleWindow, 
			UnsafeNativeMethods.IOleContainer
        {
            private UnsafeNativeMethods.IOleInPlaceActiveObject activeInPlaceObject;
            private ScrollableControl.DockPaddingEdges dockPadding;
            private MainMenu formMenu;
            private int lockCount;
            private bool menuSet;
            private int modelessCount;
            private ActiveDocumentHost owner;

			#region 属性
			/// <summary>
			/// 就地激活对象
			/// </summary>
			internal UnsafeNativeMethods.IOleInPlaceActiveObject ActiveObject
			{
				get
				{
					return this.activeInPlaceObject;
				}
			}

			/// <summary>
			/// 拥有本实例的宿主
			/// </summary>
			protected ActiveDocumentHost Owner
			{
				get
				{
					return this.owner;
				}
			}

			#endregion

			#region 构造 析构 函数

			/// <summary>
			/// 构造
			/// </summary>
			/// <param name="owner">实例拥有者</param>
			public ActiveDocumentContainer(ActiveDocumentHost owner)
			{
				this.owner = owner;
				owner.Deactivated += new EventHandler(this.OnOwnerDeactivated);
			}

			public virtual void Dispose()
			{
				if (this.activeInPlaceObject != null)
				{
					this.activeInPlaceObject = null;
				}
			}


			#endregion

			#region 方法
			/// <summary>
			/// 当拥有者冻结
			/// </summary>
			/// <param name="sender"></param>
			/// <param name="e"></param>
            private void OnOwnerDeactivated(object sender, EventArgs e)
            {
                ((UnsafeNativeMethods.IOleInPlaceFrame) this).SetMenu(IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);
                if (this.dockPadding != null)
                {
                    this.owner.ToolTarget.SuspendLayout();
                    this.owner.ToolTarget.DockPadding.Left = this.dockPadding.Left;
                    this.owner.ToolTarget.DockPadding.Top = this.dockPadding.Top;
                    this.owner.ToolTarget.DockPadding.Bottom = this.dockPadding.Bottom;
                    this.owner.ToolTarget.DockPadding.Right = this.dockPadding.Right;
                    this.owner.ToolTarget.ResumeLayout(true);
                    this.dockPadding = null;
                }
            }

			/// <summary>
			/// 更新就地激活对象边框
			/// </summary>
			internal void UpdateBorders()
			{
				if ((this.activeInPlaceObject != null) && ActiveDocumentHost.VerifyCast(this.activeInPlaceObject, typeof(UnsafeNativeMethods.IOleInPlaceActiveObject)))
				{
					NativeMethods.COMRECT comrect;
					if (!this.owner.ShowToolbars)
					{
						comrect = new NativeMethods.COMRECT();
					}
					else
					{
						comrect = new NativeMethods.COMRECT(this.owner.ToolTarget.ClientRectangle);
					}
					this.activeInPlaceObject.ResizeBorder(comrect, this, true);
				}
			}


			#endregion

			#region IOleContainer
			int UnsafeNativeMethods.IOleContainer.EnumObjects(int grfFlags, out UnsafeNativeMethods.IEnumUnknown ppEnum)
            {
                ppEnum = null;

				return NativeMethods.E_NOTIMPL;
            }


			int UnsafeNativeMethods.IOleContainer.LockContainer(bool fLock)
            {
                if (fLock)
                {
                    this.lockCount++;
                }
                else
                {
                    this.lockCount--;
                }
                return NativeMethods.S_OK;
            }

            int UnsafeNativeMethods.IOleContainer.ParseDisplayName(object pbc, string pszDisplayName, int[] pchEaten, object[] ppmkOut)
            {
				return NativeMethods.E_NOTIMPL;
            }
			#endregion

			#region IOleInPlaceFrame
			int UnsafeNativeMethods.IOleInPlaceFrame.ContextSensitiveHelp(int fEnterMode)
            {
                if (this.activeInPlaceObject == null)
                {
					return NativeMethods.E_FAIL;
                }
                this.activeInPlaceObject.ContextSensitiveHelp(fEnterMode);
				return NativeMethods.S_OK;
            }

            int UnsafeNativeMethods.IOleInPlaceFrame.EnableModeless(bool fEnable)
            {
                if (fEnable)
                {
                    this.modelessCount++;
                }
                else
                {
                    this.modelessCount--;
                }
				return NativeMethods.S_OK;
            }

            int UnsafeNativeMethods.IOleInPlaceFrame.GetBorder(NativeMethods.COMRECT borderRect)
            {
                if (!this.owner.ShowToolbars)
                {
					return NativeMethods.INPLACE_E_NOTOOLSPACE;
                }
                Rectangle clientRectangle = this.owner.ToolTarget.ClientRectangle;
                borderRect.left = clientRectangle.Left;
                borderRect.top = clientRectangle.Top;
                borderRect.bottom = clientRectangle.Bottom;
                borderRect.right = clientRectangle.Right;
                return NativeMethods.S_OK;
            }

            IntPtr UnsafeNativeMethods.IOleInPlaceFrame.GetWindow()
            {
                return this.owner.ToolTarget.Handle;
            }

            int UnsafeNativeMethods.IOleInPlaceFrame.InsertMenus(IntPtr hmenuShared, NativeMethods.tagOleMenuGroupWidths lpMenuWidths)
            {
                return NativeMethods.S_OK;
            }

            int UnsafeNativeMethods.IOleInPlaceFrame.RemoveMenus(IntPtr hmenuShared)
            {
                ((UnsafeNativeMethods.IOleInPlaceFrame) this).SetMenu(IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);
                return NativeMethods.S_OK;
            }

            int UnsafeNativeMethods.IOleInPlaceFrame.RequestBorderSpace(NativeMethods.COMRECT r)
            {
                if ((this.owner.ShowToolbars && ((r.left + r.right) <= this.owner.ToolTarget.Width)) && ((r.top + r.bottom) <= this.owner.ToolTarget.Height))
                {
                    return NativeMethods.S_OK;
                }
				return NativeMethods.INPLACE_E_NOTOOLSPACE;
            }

            int UnsafeNativeMethods.IOleInPlaceFrame.SetActiveObject(UnsafeNativeMethods.IOleInPlaceActiveObject pActiveObject, string pszObjName)
            {
                if (this.activeInPlaceObject != null)
                {
                    this.activeInPlaceObject = null;
                }
                this.activeInPlaceObject = pActiveObject;
                if (this.activeInPlaceObject == null)
                {
                    ((UnsafeNativeMethods.IOleInPlaceFrame) this).SetMenu(IntPtr.Zero, IntPtr.Zero, IntPtr.Zero);
                }
                return NativeMethods.S_OK;
            }

            int UnsafeNativeMethods.IOleInPlaceFrame.SetBorderSpace(NativeMethods.COMRECT r)
            {
                if (!this.owner.ShowToolbars)
                {
                    this.dockPadding = null;
					return NativeMethods.INPLACE_E_NOTOOLSPACE;
                }
                this.owner.ToolTarget.SuspendLayout();
                if (this.dockPadding == null)
                {
                    this.dockPadding = (ScrollableControl.DockPaddingEdges) ((ICloneable) this.owner.ToolTarget.DockPadding).Clone();
                }
                this.owner.ToolTarget.DockPadding.Left = r.left;
                this.owner.ToolTarget.DockPadding.Top = r.top;
                this.owner.ToolTarget.DockPadding.Bottom = r.bottom;
                this.owner.ToolTarget.DockPadding.Right = r.right;
                this.owner.ToolTarget.ResumeLayout(true);
                if (this.owner.adsite != null)
                {
                    this.owner.adsite.UpdateClientRect(false, Rectangle.Empty);
                }
                return NativeMethods.S_OK;
            }

            int UnsafeNativeMethods.IOleInPlaceFrame.SetMenu(IntPtr hmenuShared, IntPtr holemenu, IntPtr hwndActiveObject)
            {
                if ((this.owner.ShowMenus || (hmenuShared == IntPtr.Zero)) && ((hmenuShared != IntPtr.Zero) || this.menuSet))
                {
                    Form wrapper = this.owner.FindForm();
                    if ((wrapper != null) && (wrapper.MdiParent != null))
                    {
                        wrapper = wrapper.MdiParent;
                    }
                    if ((wrapper == null) || ((this.activeInPlaceObject == null) && (holemenu != IntPtr.Zero)))
                    {
						return NativeMethods.E_FAIL;
                    }
                    if (holemenu != IntPtr.Zero)
                    {
                        this.formMenu = wrapper.Menu;
                        wrapper.Menu = null;
                    }
                    if (wrapper.IsMdiContainer)
                    {
                        if (hmenuShared != IntPtr.Zero)
                        {
							UnsafeNativeMethods.SendMessage(new HandleRef(FormShim.GetMdiClient(wrapper), FormShim.GetMdiClient(wrapper).Handle), 560, hmenuShared, IntPtr.Zero);
                            SafeNativeMethods.DrawMenuBar(new HandleRef(wrapper, wrapper.Handle));
                        }
                    }
                    else
                    {
                        UnsafeNativeMethods.SetMenu(new HandleRef(wrapper, wrapper.Handle), new HandleRef(this, hmenuShared));
                    }
                    UnsafeNativeMethods.OleSetMenuDescriptor(holemenu, wrapper.Handle, hwndActiveObject, this, this.activeInPlaceObject);
                    if (holemenu == IntPtr.Zero)
                    {
                        if (this.formMenu != null)
                        {
                            wrapper.Menu = this.formMenu;
                            this.formMenu = null;
                        }
                        this.menuSet = false;
                    }
                    else
                    {
                        this.menuSet = true;
                    }
                    wrapper.PerformLayout();
                }
                return NativeMethods.S_OK;
            }

            int UnsafeNativeMethods.IOleInPlaceFrame.SetStatusText(string pszStatusText)
            {
                this.Owner.SetStatusTextInternal(pszStatusText);
                return NativeMethods.S_OK;
            }

            int UnsafeNativeMethods.IOleInPlaceFrame.TranslateAccelerator(ref NativeMethods.MSG lpmsg, short wID)
            {
                if ((wID == 0x1b) && (lpmsg.wParam == ((IntPtr) wID)))
                {
                    this.Owner.Deactivate();
                    return NativeMethods.S_OK;
                }
                return NativeMethods.S_FALSE;
            }
			#endregion

			#region IOleInPlaceUIWindow
			int UnsafeNativeMethods.IOleInPlaceUIWindow.ContextSensitiveHelp(int fEnterMode)
            {
                return ((UnsafeNativeMethods.IOleInPlaceFrame) this).ContextSensitiveHelp(fEnterMode);
            }

            int UnsafeNativeMethods.IOleInPlaceUIWindow.GetBorder(NativeMethods.COMRECT lprectBorder)
            {
                return ((UnsafeNativeMethods.IOleInPlaceFrame) this).GetBorder(lprectBorder);
            }

            IntPtr UnsafeNativeMethods.IOleInPlaceUIWindow.GetWindow()
            {
                return ((UnsafeNativeMethods.IOleInPlaceFrame) this).GetWindow();
            }

            int UnsafeNativeMethods.IOleInPlaceUIWindow.RequestBorderSpace(NativeMethods.COMRECT pborderwidths)
            {
                return ((UnsafeNativeMethods.IOleInPlaceFrame) this).RequestBorderSpace(pborderwidths);
            }

            void UnsafeNativeMethods.IOleInPlaceUIWindow.SetActiveObject(UnsafeNativeMethods.IOleInPlaceActiveObject pActiveObject, string pszObjName)
            {
                ((UnsafeNativeMethods.IOleInPlaceFrame) this).SetActiveObject(pActiveObject, pszObjName);
            }

            int UnsafeNativeMethods.IOleInPlaceUIWindow.SetBorderSpace(NativeMethods.COMRECT pborderwidths)
            {
                return ((UnsafeNativeMethods.IOleInPlaceFrame) this).SetBorderSpace(pborderwidths);
            }

			#endregion

			#region IOleWindow
			void UnsafeNativeMethods.IOleWindow.ContextSensitiveHelp(int fEnterMode)
            {
            }

            int UnsafeNativeMethods.IOleWindow.GetWindow(out IntPtr pHwnd)
            {
                pHwnd = this.owner.ToolTarget.Handle;
				return NativeMethods.S_OK;
            }
			#endregion

        }
		#endregion

		#region ActiveDocumentSite

		/*
		 * 做为OLE容器必须实现的接口有3个，分别是IOleClientSite、IAdviseSink、IOleInPlaceSite，
		 * 以下分别来介绍。（由于每一个接口都是从IUnknown继承，因此IUnknown的方法实现在介绍时略去）
		 */
		protected class ActiveDocumentSite : 
			StandardOleMarshalObject, 
			UnsafeNativeMethods.IOleWindow, 
			UnsafeNativeMethods.IOleClientSite, 
			/*IOleClientSite接口用来为OLE对象提供一个启动时的“站点”接口，
			 * 主要用来为OLE对象提供窗口位置、用户界面、资源、名字服务的信息，
			 * OLE对象在启动时需要查询和调用这个接口来安排自身事务。
			 * 每一个OLE对象都需要对应有一个IOleClientSite接口，
			 * 因此如果在应用程序中同时启动多个OLE对象，他们必须共享或者独立拥有一个IOleClientSite接口。
			 * IOleClientSite包含了方法SaveObject、GetMoniker、GetContainer、ShowObject、OnShowWindow、RequestNewObjectLayout
			 * （关于具体的说明读者可以参看MSDN，在此不一一讨论，下同）。
			 * 其中仅仅有SaveObject方法比较重要，需要实现，其他方法均可简单返回（返回S_OK值）或者声明为未实现（返回E_NOTIMPL值）。 
			 */
			IAdviseSink, 
			/*IAdviseSink接口用来使得包容可以在OLE对象的数据改变、试图改变、文档改变时有机会响应。
			 * 需要注意的是，IAdviseSink接口的方法被OLE对象调用时都是同步的，因此如果包容在响应这些调用时耗费过长的时间（例如大规模的计算），
			 * 会造成用户界面“僵死”现象。IAdviseSink包含了方法OnDataChange、OnViewChange、OnRename、OnSave、OnClose。实现时按照需要实现，
			 * 甚至全部可以简单返回。另外一点需要注意的是，OLE对象不会主动的获取包容的IAdviseSink接口，因此我们必须通过在创建OLE对象后，
			 * 调用OLE对象IOleObject接口的Advise方法来向对象“注册”这个接口。 
			 */

			UnsafeNativeMethods.IOleInPlaceSite, 
			/*IOleInPlaceSite接口从IOleWindow接口继承而来，用来在OLE包容和OLE对象之间维持一种互相联系，
			 * 例如OLE对象可以从OLE包容获得上下文窗口位置的信息，
			 * OLE包容也可以在OLE对象实地激活时获得通知以做出相应的安排。
			 * IOleInPlaceSite包含了方法GetWindow、ContextSensitiveHelp
			 * （这两个方法是从IOleWindow继承而来）、IOleInPlaceSite、CanInPlaceActivate、
			 * OnInPlaceActivate   OnUIActivate、GetWindowContext、Scroll、OnUIDeactivate、
			 * OnInPlaceDeactivate、DiscardUndoState、DeactivateAndUndo、OnPosRectChange。
			 * 一般而言，比较重要的是：GetWindowContext，OLE对象可以在此获得OLE包容的一些设定信息，
			 * 以作自身响应；GetWindow，OLE对象需要在这里获得母窗口句柄；
			 * OnUIActive、OnUIDeactive、OnInPlaceActive、OnInPlaceDeactive、DeactiveAndUndo，
			 * 这些都是OLE对象在试图变化时的一些通知函数，OLE包容需要在这时为OLE对象安排好诸如菜单等等资源的协调，
			 * 以及调用OLE对象做复合文档的永久化、回复等等，都是比较简单的实现。
			 * 其他的接口函数均可按需要实现，否则简单返回即可。
			 */
			UnsafeNativeMethods.IOleServiceProvider, 
			IDisposable
        {

			private ActiveDocumentHost owner;

            private UnsafeNativeMethods.IOleInPlaceObject activeObject;
			private ActiveDocumentHost.OleObjectPlaceholder oleObjectPlaceholder;

            private int adviseCookie;
            private int dAdviseCookie;
            private bool dataChanged;
            private bool deactivating;
            private IntPtr hAccelTable = IntPtr.Zero;
            private static readonly int hiMetricPerInch = 0x9ec;
            private int innerState;
            private bool lockedRunning;
            private static Point logPixels = Point.Empty;
            private Rectangle oleParentBounds = Rectangle.Empty;
            
            private const int StateInactive = 0;
            private const int StateInPlaceActive = 1;
            private const int StateUiActive = 2;
            private bool suppressEvents;

			#region 属性
			internal bool DataChanged
			{
				get
				{
					return this.dataChanged;
				}
				set
				{
					this.dataChanged = value;
					if (value)
					{
						this.Owner.OnDocumentModified(EventArgs.Empty);
						if (this.Owner.AutoSize)
						{
							this.Owner.Size = this.PreferredSize;
						}
					}
				}
			}


			private Point LogPixels
			{
				get
				{
					if (logPixels.IsEmpty)
					{
						logPixels = new Point();
						IntPtr dC = UnsafeNativeMethods.GetDC(new HandleRef(this, IntPtr.Zero));
						logPixels.X = UnsafeNativeMethods.GetDeviceCaps(new HandleRef(this, dC), 0x58);
						logPixels.Y = UnsafeNativeMethods.GetDeviceCaps(new HandleRef(this, dC), 90);
						UnsafeNativeMethods.ReleaseDC(new HandleRef(this, IntPtr.Zero), new HandleRef(this, dC));
					}
					return logPixels;
				}
			}

			private Control OleObjectParent
			{
				get
				{
					Control owner = this.owner;
					while (owner.Parent != null)
					{
						owner = owner.Parent;
					}
					return owner;
				}
			}

			protected ActiveDocumentHost Owner
			{
				get
				{
					return this.owner;
				}
			}

			internal Size PreferredSize
			{
				get
				{
					NativeMethods.tagSIZEL pSizel = new NativeMethods.tagSIZEL();
					if (!NativeMethods.Succeeded(this.Owner.OleObject.GetExtent(this.Owner.DisplayAsIcon ? 4 : 1, pSizel)))
					{
						pSizel.cx = 0;
						pSizel.cy = 0;
					}
					if ((pSizel.cx == 0) || (pSizel.cy == 0))
					{
						return Size.Empty;
					}
					Size size = this.HiMetricToPixel(pSizel.cx, pSizel.cy);
					size.Width += 2;
					size.Height += 2;
					return size;
				}
			}

			#endregion

			#region 构造
			/// <summary>
			/// 构造
			/// </summary>
			/// <param name="owner">拥有者</param>
			public ActiveDocumentSite(ActiveDocumentHost owner)
            {
                this.owner = owner;
                this.oleObjectPlaceholder = new ActiveDocumentHost.OleObjectPlaceholder();
                this.oleObjectPlaceholder.Click += new EventHandler(this.OleObjectPlaceholder_Click);
                this.oleObjectPlaceholder.DoubleClick += new EventHandler(this.OleObjectPlaceholder_DoubleClick);
                this.oleObjectPlaceholder.GotFocus += new EventHandler(this.OleObjectPlaceholder_GotFocus);
                this.oleObjectPlaceholder.LostFocus += new EventHandler(this.OleObjectPlaceholder_LostFocus);
                this.oleObjectPlaceholder.KeyDown += new KeyEventHandler(this.OleObjectPlaceholder_KeyDown);
                this.oleObjectPlaceholder.SizeChanged += new EventHandler(this.OleObjectPlaceholder_SizeChanged);
                this.oleObjectPlaceholder.Paint += new PaintEventHandler(this.OleObjectPlaceholder_Paint);
                this.oleObjectPlaceholder.Dock = DockStyle.Fill;
                owner.Controls.Add(this.oleObjectPlaceholder);
                owner.Loaded += new EventHandler(this.OnOleObjectLoaded);
                this.innerState = 0;
            }

			#endregion

			#region 方法


			private void SetFocusActiveObject()
			{
				if (this.activeObject != null)
				{
					IntPtr zero = IntPtr.Zero;
					if (NativeMethods.Succeeded(this.activeObject.GetWindow(out zero)))
					{
						SafeNativeMethods.SetWindowPos(new HandleRef(this, zero), NativeMethods.HWND_TOP, 0, 0, 0, 0, 0x13);
						UnsafeNativeMethods.SetFocus(new HandleRef(this, zero));
					}
				}
			}

			private void DoHostEvents()
			{
			}

			private void EnsureAcceleratorTable()
			{
				if (this.hAccelTable == IntPtr.Zero)
				{
					IntPtr ptr = Marshal.AllocHGlobal(Marshal.SizeOf(typeof(NativeMethods.ACCEL)));
					try
					{
						NativeMethods.ACCEL structure = new NativeMethods.ACCEL();
						structure.cmd = 0x1b;
						structure.fVirt = 1;
						structure.key = 0x1b;
						Marshal.StructureToPtr(structure, ptr, false);
						this.hAccelTable = UnsafeNativeMethods.CreateAcceleratorTable(new HandleRef(null, ptr), 1);
					}
					finally
					{
						if (ptr != IntPtr.Zero)
						{
							Marshal.FreeHGlobal(ptr);
						}
					}
				}
			}

			private void GetObjectRects(ref Rectangle posRect, ref Rectangle clipRect, bool uiActive)
			{
				bool flag = posRect == Rectangle.Empty;
				if (flag)
				{
					posRect = this.ComputeDrawRect();
				}
				posRect.Inflate(-2, -2);
				clipRect = this.oleObjectPlaceholder.ClientRectangle;
				if (uiActive)
				{
					if (flag)
					{
						Rectangle rectangle = this.OleObjectParent.RectangleToClient(this.oleObjectPlaceholder.RectangleToScreen(this.oleObjectPlaceholder.ClientRectangle));
						posRect.X += rectangle.X;
						posRect.Y += rectangle.Y;
					}
					NativeMethods.tagSIZEL pSizel = new NativeMethods.tagSIZEL();
					this.Owner.OleObject.GetExtent(1, pSizel);
					Size size = this.HiMetricToPixel(pSizel.cx, pSizel.cy);
					clipRect = this.OleObjectParent.ClientRectangle;
					if (this.Owner.SizeMode == DocumentSizeMode.Clip)
					{
						if ((size.Width - 4) <= clipRect.Width)
						{
							clipRect.Width = 0x7fff;
						}
						if ((size.Height - 4) <= clipRect.Height)
						{
							clipRect.Height = 0x7fff;
						}
					}
					else
					{
						clipRect.Width = 0x7fff;
						clipRect.Height = 0x7fff;
					}
				}
			}

			private Size HiMetricToPixel(int x, int y)
			{
				return new Size(((this.LogPixels.X * x) + (hiMetricPerInch / 2)) / hiMetricPerInch, ((this.LogPixels.Y * y) + (hiMetricPerInch / 2)) / hiMetricPerInch);
			}
			private Rectangle ComputeDrawRect()
            {
                Rectangle empty = Rectangle.Empty;
                int dwDrawAspect = this.Owner.DisplayAsIcon ? 4 : 1;
                NativeMethods.tagSIZEL lpsizel = new NativeMethods.tagSIZEL();
                UnsafeNativeMethods.IOleObject oleObject = this.Owner.OleObject;
                UnsafeNativeMethods.IViewObject2 obj3 = this.Owner.OleObject as UnsafeNativeMethods.IViewObject2;
                if (obj3 != null)
                {
                    obj3.GetExtent(dwDrawAspect, -1, null, lpsizel);
                }
                else if (!NativeMethods.Succeeded(oleObject.GetExtent(dwDrawAspect, lpsizel)))
                {
                    lpsizel.cx = 0;
                    lpsizel.cy = 0;
                }
                if ((lpsizel.cx == 0) || (lpsizel.cy == 0))
                {
                    return this.oleObjectPlaceholder.ClientRectangle;
                }
                Size size2 = this.HiMetricToPixel(lpsizel.cx, lpsizel.cy);
                Size size = this.oleObjectPlaceholder.ClientRectangle.Size;
                Rectangle rectangle2 = new Rectangle(0, 0, size.Width, size.Height);
                DocumentSizeMode sizeMode = this.Owner.SizeMode;
                if (this.Owner.AutoSize)
                {
                    sizeMode = DocumentSizeMode.Clip;
                }
                switch (sizeMode)
                {
                    case DocumentSizeMode.Clip:
                        empty.X = 0;
                        empty.Y = 0;
                        empty.Width = size2.Width;
                        empty.Height = size2.Height;
                        return empty;

                    case DocumentSizeMode.Stretch:
                        return rectangle2;

                    case DocumentSizeMode.Zoom:
                        empty = rectangle2;
                        if ((size2.Width * size.Height) >= (size.Width * size2.Height))
                        {
                            empty.Height = ((int) ((size2.Height * size.Width) / ((long) size2.Width))) - empty.Top;
                            return empty;
                        }
                        empty.Width = ((int) ((size2.Width * size.Height) / ((long) size2.Height))) - empty.Left;
                        return empty;
                }
                return empty;
            }

			#endregion

			#region 析构
			public void Dispose()
            {
                if (this.owner.OleObject != null)
                {
                    try
                    {
                        this.owner.OleObject.Close(1);
                    }
                    catch (Exception)
                    {
                    }
                    if (this.lockedRunning)
                    {
                        UnsafeNativeMethods.OleLockRunning(this.owner.OleObject, false, true);
                        this.lockedRunning = false;
                    }
                }
                if ((this.adviseCookie != 0) && (this.owner.OleObject != null))
                {
                    try
                    {
                        this.owner.OleObject.Unadvise(this.adviseCookie);
                    }
                    catch (Exception)
                    {
                    }
                    this.adviseCookie = 0;
                }
                if ((this.dAdviseCookie != 0) && (this.owner.OleObject is System.Runtime.InteropServices.ComTypes.IDataObject))
                {
                    try
                    {
                        ((System.Runtime.InteropServices.ComTypes.IDataObject) this.owner.OleObject).DUnadvise(this.dAdviseCookie);
                    }
                    catch
                    {
                    }
                    this.dAdviseCookie = 0;
                }
                if (this.activeObject != null)
                {
                    this.activeObject = null;
                }
                if ((this.owner != null) && (this.oleObjectPlaceholder != null))
                {
                    this.oleObjectPlaceholder.Dispose();
                    this.oleObjectPlaceholder = null;
                }
                if (this.owner != null)
                {
                    this.owner.Loaded -= new EventHandler(this.OnOleObjectLoaded);
                }
                if (this.hAccelTable != IntPtr.Zero)
                {
                    UnsafeNativeMethods.DestroyAcceleratorTable(new HandleRef(this, this.hAccelTable));
                    this.hAccelTable = IntPtr.Zero;
                }
                this.owner = null;
            }

			#endregion

			#region OleObjectPlaceholder 事件
			private void OleObjectPlaceholder_Click(object sender, EventArgs e)
            {
                this.oleObjectPlaceholder.Focus();
                if (this.owner.ActivationGesture == ActivationGesture.Click)
                {
                    this.UIActivate();
                }
            }

            private void OleObjectPlaceholder_DoubleClick(object sender, EventArgs e)
            {
                if (this.owner.ActivationGesture == ActivationGesture.DoubleClick)
                {
                    this.UIActivate();
                }
            }

            private void OleObjectPlaceholder_GotFocus(object sender, EventArgs e)
            {
                this.oleObjectPlaceholder.Invalidate();
                if (this.owner.ActivationGesture == ActivationGesture.Focus)
                {
                    this.UIActivate();
                }
                this.SetFocusActiveObject();
            }

            private void OleObjectPlaceholder_KeyDown(object sender, KeyEventArgs e)
            {
                if ((e.KeyCode == Keys.Return) && (this.owner.ActivationGesture != ActivationGesture.Never))
                {
                    this.UIActivate();
                }
            }

            private void OleObjectPlaceholder_LostFocus(object sender, EventArgs e)
            {
                this.oleObjectPlaceholder.Invalidate();
            }

            private void OleObjectPlaceholder_Paint(object sender, PaintEventArgs e)
            {
                if (this.activeObject == null)
                {
                    IntPtr hdc = e.Graphics.GetHdc();
                    try
                    {
                        UnsafeNativeMethods.IViewObject oleObject = this.owner.OleObject as UnsafeNativeMethods.IViewObject;
                        if (oleObject != null)
                        {
                            NativeMethods.COMRECT lprcBounds = new NativeMethods.COMRECT(this.ComputeDrawRect());
                            oleObject.Draw(this.Owner.DisplayAsIcon ? 4 : 1, -1, IntPtr.Zero, null, IntPtr.Zero, hdc, lprcBounds, null, IntPtr.Zero, 0);
                        }
                    }
                    finally
                    {
                        e.Graphics.ReleaseHdc(hdc);
                    }
                }
                switch (this.owner.BorderStyle)
                {
                    case BorderStyle.FixedSingle:
                        ControlPaint.DrawBorder(e.Graphics, this.oleObjectPlaceholder.ClientRectangle, this.owner.ForeColor, ButtonBorderStyle.Solid);
                        break;

                    case BorderStyle.Fixed3D:
                        ControlPaint.DrawBorder3D(e.Graphics, this.oleObjectPlaceholder.ClientRectangle);
                        break;
                }
                if (this.oleObjectPlaceholder.Focused)
                {
                    Rectangle clientRectangle = this.oleObjectPlaceholder.ClientRectangle;
                    clientRectangle.Inflate(-2, -2);
                    ControlPaint.DrawFocusRectangle(e.Graphics, clientRectangle);
                }
            }

            private void OleObjectPlaceholder_SizeChanged(object sender, EventArgs e)
            {
                if (this.oleObjectPlaceholder.ClientRectangle != this.oleParentBounds)
                {
                    this.UpdateExtent();
                    this.oleParentBounds = this.oleObjectPlaceholder.ClientRectangle;
                }
            }

			#endregion

			private void OnOleObjectLoaded(object sender, EventArgs e)
            {
                if (this.adviseCookie == 0)
                {
                    this.owner.OleObject.Advise(this, out this.adviseCookie);
                }
                if ((this.dAdviseCookie == 0) && (this.owner.OleObject is System.Runtime.InteropServices.ComTypes.IDataObject))
                {
                    FORMATETC pFormatetc = new FORMATETC();
					pFormatetc.dwAspect = (DVASPECT)( - 1);
                    pFormatetc.lindex = -1;
                    pFormatetc.tymed = ~TYMED.TYMED_NULL;
                    ((System.Runtime.InteropServices.ComTypes.IDataObject) this.owner.OleObject).DAdvise(ref pFormatetc, ADVF.ADVF_NODATA, this, out this.dAdviseCookie);
                }
            }

            internal void OnSizeModeChanged(object sender, EventArgs e)
            {
                this.UpdateExtent();
                this.oleObjectPlaceholder.Invalidate();
            }

			#region IAdviseSink
			void IAdviseSink.OnClose()
            {
                this.DataChanged = false;
            }

            void IAdviseSink.OnDataChange(ref FORMATETC pFormatetc, ref STGMEDIUM pStgmed)
            {
                this.DataChanged = true;
            }

            void IAdviseSink.OnRename(IMoniker moniker)
            {
            }

            void IAdviseSink.OnSave()
            {
                this.DataChanged = false;
                this.Owner.OnSaved(EventArgs.Empty);
            }

            void IAdviseSink.OnViewChange(int dwAspect, int lindex)
            {
            }

			#endregion

			#region UnsafeNativeMethods.IOleClientSite
			int UnsafeNativeMethods.IOleClientSite.GetContainer(out UnsafeNativeMethods.IOleContainer container)
            {
                container = this.Owner.AdContainer;
                return 0;
            }

            int UnsafeNativeMethods.IOleClientSite.GetMoniker(int dwAssign, int dwWhichMoniker, out object moniker)
            {
                moniker = null;
                return NativeMethods.E_NOTIMPL;
            }

            int UnsafeNativeMethods.IOleClientSite.OnShowWindow(int fShow)
            {
                return 0;
            }

            int UnsafeNativeMethods.IOleClientSite.RequestNewObjectLayout()
            {
                return NativeMethods.E_NOTIMPL;
            }

            int UnsafeNativeMethods.IOleClientSite.SaveObject()
            {
                UnsafeNativeMethods.IPersistStorage oleObject = this.Owner.OleObject as UnsafeNativeMethods.IPersistStorage;
                if ((oleObject != null) && (oleObject.IsDirty() == 0))
                {
                    NativeMethods.Succeeded(UnsafeNativeMethods.OleSave(oleObject, this.Owner.Storage, true));
                }
                return 0;
            }

            int UnsafeNativeMethods.IOleClientSite.ShowObject()
            {
                return 0;
            }

			#endregion

			#region UnsafeNativeMethods.IOleInPlaceSite
			int UnsafeNativeMethods.IOleInPlaceSite.CanInPlaceActivate()
            {
                return 0;
            }

            int UnsafeNativeMethods.IOleInPlaceSite.ContextSensitiveHelp(int fEnterMode)
            {
                return ((UnsafeNativeMethods.IOleInPlaceFrame) this.Owner.AdContainer).ContextSensitiveHelp(fEnterMode);
            }

            int UnsafeNativeMethods.IOleInPlaceSite.DeactivateAndUndo()
            {
                if (this.activeObject != null)
                {
                    this.activeObject.InPlaceDeactivate();
                }
                return 0;
            }

            int UnsafeNativeMethods.IOleInPlaceSite.DiscardUndoState()
            {
                return NativeMethods.E_NOTIMPL;
            }

            IntPtr UnsafeNativeMethods.IOleInPlaceSite.GetWindow()
            {
                return this.OleObjectParent.Handle;
            }

            int UnsafeNativeMethods.IOleInPlaceSite.GetWindowContext(out UnsafeNativeMethods.IOleInPlaceFrame ppFrame, out UnsafeNativeMethods.IOleInPlaceUIWindow ppDoc, NativeMethods.COMRECT lprcPosRect, NativeMethods.COMRECT lprcClipRect, NativeMethods.tagOIFI lpFrameInfo)
            {
                if (((lprcPosRect == null) || (lprcClipRect == null)) || (lpFrameInfo == null))
                {
                    ppFrame = null;
                    ppDoc = null;
                    return NativeMethods.E_INVALIDARG;
                }
                ppFrame = this.Owner.AdContainer;
                ppDoc = null;
                Rectangle empty = Rectangle.Empty;
                Rectangle clipRect = Rectangle.Empty;
                this.GetObjectRects(ref empty, ref clipRect, true);
                new NativeMethods.COMRECT(empty).CopyTo(lprcPosRect);
                new NativeMethods.COMRECT(clipRect).CopyTo(lprcClipRect);
                Form form = this.Owner.FindForm();
                lpFrameInfo.cb = Marshal.SizeOf(typeof(NativeMethods.tagOIFI));
                lpFrameInfo.fMDIApp = (form != null) && (form.MdiParent != null);
                lpFrameInfo.hwndFrame = this.owner.ToolTarget.Handle;
                this.EnsureAcceleratorTable();
                lpFrameInfo.hAccel = this.hAccelTable;
                lpFrameInfo.cAccelEntries = 1;
                return 0;
            }

            int UnsafeNativeMethods.IOleInPlaceSite.OnInPlaceActivate()
            {
                this.activeObject = (UnsafeNativeMethods.IOleInPlaceObject) this.owner.OleObject;
                if (!this.lockedRunning)
                {
                    UnsafeNativeMethods.OleLockRunning(this.owner.OleObject, true, false);
                    this.lockedRunning = true;
                }
                this.UpdateActivationState(1);
                this.oleObjectPlaceholder.Invalidate();
                return 0;
            }

            int UnsafeNativeMethods.IOleInPlaceSite.OnInPlaceDeactivate()
            {
                IntPtr handle = this.OleObjectParent.Handle;
                NativeMethods.COMRECT lprcPosRect = new NativeMethods.COMRECT(this.OleObjectParent.ClientRectangle);
				this.Owner.OleObject.DoVerb(NativeMethods.OLEIVERB_DISCARDUNDOSTATE, IntPtr.Zero, this, 0, handle, lprcPosRect);
                if (this.activeObject != null)
                {
                    this.activeObject = null;
                }
                this.UpdateExtent();
                this.UpdateActivationState(0);
                return 0;
            }

            int UnsafeNativeMethods.IOleInPlaceSite.OnPosRectChange(NativeMethods.COMRECT lprcPosRect)
            {
                this.UpdateClientRect(false, new Rectangle(lprcPosRect.left, lprcPosRect.top, lprcPosRect.right - lprcPosRect.left, lprcPosRect.bottom - lprcPosRect.top));
                return 0;
            }

            int UnsafeNativeMethods.IOleInPlaceSite.OnUIActivate()
            {
                this.UpdateActivationState(2);
                this.SetFocusActiveObject();
                this.UpdateClientRect(true, Rectangle.Empty);
                this.oleObjectPlaceholder.Invalidate();
                return 0;
            }

            int UnsafeNativeMethods.IOleInPlaceSite.OnUIDeactivate(int fUndoable)
            {
                this.Deactivate();
                return 0;
            }

            int UnsafeNativeMethods.IOleInPlaceSite.Scroll(NativeMethods.tagSIZE scrollExtant)
            {
                return NativeMethods.E_NOTIMPL;
            }
			#endregion

			#region UnsafeNativeMethods.IOleServiceProvider
			int UnsafeNativeMethods.IOleServiceProvider.QueryService(ref Guid guidService, ref Guid riid, out IntPtr ppvObject)
            {
                ppvObject = IntPtr.Zero;
                return NativeMethods.E_NOINTERFACE;
            }
			#endregion

			#region UnsafeNativeMethods.IOleWindow
			void UnsafeNativeMethods.IOleWindow.ContextSensitiveHelp(int fEnterMode)
            {
            }

            int UnsafeNativeMethods.IOleWindow.GetWindow(out IntPtr pHwnd)
            {
                pHwnd = this.OleObjectParent.Handle;
                return 0;
            }
			#endregion

			internal void UIActivate()
            {
                this.oleObjectPlaceholder.Focus();
                this.DoHostEvents();
                try
                {
                    this.suppressEvents = true;
                    NativeMethods.COMRECT lprcPosRect = new NativeMethods.COMRECT(this.OleObjectParent.ClientRectangle);
					if (!NativeMethods.Succeeded(this.owner.OleObject.DoVerb(NativeMethods.OLECLOSE_SAVEIFDIRTY, IntPtr.Zero, this, 0, this.OleObjectParent.Handle, lprcPosRect)))
                    {
						this.owner.OleObject.DoVerb(NativeMethods.OLEIVERB_UIACTIVATE, IntPtr.Zero, this, 0, this.OleObjectParent.Handle, lprcPosRect);
                    }
                }
                finally
                {
                    this.suppressEvents = false;
                    this.UpdateActivationState(this.innerState);
                }
            }

			internal void Deactivate()
			{
				if (!this.deactivating && (this.activeObject != null))
				{
					try
					{
						this.deactivating = true;
						this.suppressEvents = true;
						this.activeObject.InPlaceDeactivate();
						this.DoHostEvents();
						this.oleObjectPlaceholder.Invalidate();
					}
					finally
					{
						this.deactivating = false;
						this.suppressEvents = false;
						this.UpdateActivationState(this.innerState);
					}
				}
			}

            private void UpdateActivationState(int newState)
            {
                this.innerState = newState;
                if (!this.suppressEvents)
                {
                    ActivationState none = ActivationState.None;
                    switch (this.innerState)
                    {
                        case 0:
                            none = ActivationState.Inactive;
                            break;

                        case 1:
                        case 2:
                            none = ActivationState.Active;
                            break;

                        default:
                            none = ActivationState.Inactive;
                            break;
                    }
                    this.Owner.SetActivationStateInternal(none);
                }
            }

            internal void UpdateClientRect(bool updateBorders, Rectangle preferredRect)
            {
                if (this.activeObject != null)
                {
                    Rectangle clientRectangle = this.OleObjectParent.ClientRectangle;
                    Rectangle posRect = preferredRect;
                    this.GetObjectRects(ref posRect, ref clientRectangle, this.innerState == 2);
                    NativeMethods.COMRECT lprcPosRect = new NativeMethods.COMRECT(posRect);
                    NativeMethods.COMRECT lprcClipRect = new NativeMethods.COMRECT(clientRectangle);
                    if (ActiveDocumentHost.VerifyCast(this.activeObject, typeof(UnsafeNativeMethods.IOleInPlaceObject)))
                    {
                        this.activeObject.SetObjectRects(lprcPosRect, lprcClipRect);
                    }
                    if (updateBorders)
                    {
                        this.owner.AdContainer.UpdateBorders();
                    }
                }
            }

            internal void UpdateExtent()
            {
                if (this.innerState >= 1)
                {
                    this.UpdateClientRect(false, Rectangle.Empty);
                }
            }
        }
		#endregion

		#region OleObjectPlaceholder

		/// <summary>
		/// OleObject 占位控件
		/// </summary>
		private class OleObjectPlaceholder : Control
        {
            public const int BorderWidth = 2;

			/// <summary>
			/// 构造
			/// </summary>
            internal OleObjectPlaceholder()
            {
				//可接受焦点 大小改变时重绘
                base.SetStyle(ControlStyles.Selectable | ControlStyles.ResizeRedraw, true);
            }

            protected override void Dispose(bool d)
            {
                if (base.Parent != null)
                {
                    base.Parent.TabStopChanged -= new EventHandler(this.OnParentTabStopChanged);
                }
                base.Dispose(d);
            }

			/*
            internal override bool FocusInternal()
            {
                if (this.Focused && (this.ParentInternal != null))
                {
                    IContainerControl containerControlInternal = this.ParentInternal.GetContainerControlInternal();
                    if (containerControlInternal != null)
                    {
                        containerControlInternal.ActiveControl = null;
                    }
                }
                return base.FocusInternal();
            }
			*/

			/// <summary>
			/// 父改变
			/// </summary>
			/// <param name="e"></param>
            protected override void OnParentChanged(EventArgs e)
            {
                base.OnParentChanged(e);
                if (base.Parent != null)
                {
                    base.TabStop = base.Parent.TabStop;
                    base.Parent.TabStopChanged += new EventHandler(this.OnParentTabStopChanged);
                }
            }

            private void OnParentTabStopChanged(object sender, EventArgs e)
            {
                if ((base.Parent != null) && (sender == base.Parent))
                {
                    base.TabStop = base.Parent.TabStop;
                }
            }
        }
		#endregion

		#region ToolTargetConverter
		internal class ToolTargetConverter : ComponentConverter
        {
            public ToolTargetConverter(Type t) : base(t)
            {
            }

            public override bool GetPropertiesSupported(ITypeDescriptorContext context)
            {
                return false;
            }

            public override TypeConverter.StandardValuesCollection GetStandardValues(ITypeDescriptorContext context)
            {
                TypeConverter.StandardValuesCollection standardValues = base.GetStandardValues(context);
                ArrayList values = new ArrayList(standardValues.Count);
                foreach (object obj2 in standardValues)
                {
                    if ((obj2 != null) && (!(obj2 is ActiveDocumentHost) || (obj2 == context.Instance)))
                    {
                        values.Add(obj2);
                    }
                }
                return new TypeConverter.StandardValuesCollection(values);
            }
		}
		#endregion


	}
}

