﻿namespace LabsB.Controls
{
    using System;
    using System.Drawing;
    using LabsB.Controls.Internal;
    using System.IO;
    using System.Runtime.InteropServices;
    using System.Runtime.InteropServices.ComTypes;
    using System.Security;
    using System.Security.Permissions;
    using System.Text;
    using System.Windows.Forms.VisualStyles;
	using System.Windows.Forms;

    [SuppressUnmanagedCodeSecurity]
    internal class SafeNativeMethods
    {
        [DllImport("comctl32.dll", ExactSpelling=true)]
        private static extern bool _TrackMouseEvent(NativeMethods.TRACKMOUSEEVENT tme);
        [DllImport("user32.dll", CharSet=CharSet.Auto, ExactSpelling=true)]
        public static extern IntPtr ActivateKeyboardLayout(HandleRef hkl, int uFlags);
        [DllImport("user32.dll", CharSet=CharSet.Auto, ExactSpelling=true)]
        public static extern bool AdjustWindowRectEx(ref NativeMethods.RECT lpRect, int dwStyle, bool bMenu, int dwExStyle);
        [DllImport("gdi32.dll", CharSet=CharSet.Auto, SetLastError=true)]
        public static extern bool AngleArc(HandleRef hDC, int x, int y, int radius, float startAngle, float sweepAngle);
        [DllImport("gdi32.dll", CharSet=CharSet.Auto, SetLastError=true)]
        public static extern bool Arc(HandleRef hDC, int nLeftRect, int nTopRect, int nRightRect, int nBottomRect, int nXStartArc, int nYStartArc, int nXEndArc, int nYEndArc);
        [DllImport("kernel32.dll", ExactSpelling=true)]
        public static extern bool Beep(int dwFreq, int dwDuration);
        [DllImport("gdi32.dll", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        public static extern bool BeginPath(HandleRef hDC);
        [DllImport("gdi32.dll", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        public static extern bool BitBlt(HandleRef hDC, int x, int y, int nWidth, int nHeight, HandleRef hSrcDC, int xSrc, int ySrc, int dwRop);
        [DllImport("comdlg32.dll", CharSet=CharSet.Auto, SetLastError=true)]
        public static extern bool ChooseColor([In, Out] NativeMethods.CHOOSECOLOR cc);
        [DllImport("comdlg32.dll", CharSet=CharSet.Auto, SetLastError=true)]
        public static extern bool ChooseFont([In, Out] NativeMethods.CHOOSEFONT cf);
        [DllImport("uxtheme.dll", CharSet=CharSet.Auto)]
        public static extern IntPtr CloseThemeData(HandleRef hTheme);
        public static Color ColorFromCOLORREF(int colorref)
        {
            int red = colorref & 0xff;
            int green = (colorref >> 8) & 0xff;
            int blue = (colorref >> 0x10) & 0xff;
            return Color.FromArgb(red, green, blue);
        }

        public static int ColorToCOLORREF(Color color)
        {
            return ((color.R | (color.G << 8)) | (color.B << 0x10));
        }

        [DllImport("gdi32.dll", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        public static extern int CombineRgn(HandleRef hRgn, HandleRef hRgn1, HandleRef hRgn2, int nCombineMode);
        [DllImport("comdlg32.dll", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        public static extern int CommDlgExtendedError();
        public static IntPtr CopyImage(HandleRef hImage, int uType, int cxDesired, int cyDesired, int fuFlags)
        {
            return LabsB.Controls.Internal.HandleCollector.Add(IntCopyImage(hImage, uType, cxDesired, cyDesired, fuFlags), NativeMethods.CommonHandles.GDI);
        }

        public static IntPtr CreateBitmap(int nWidth, int nHeight, int nPlanes, int nBitsPerPixel)
        {
            return LabsB.Controls.Internal.HandleCollector.Add(IntCreateBitmapByte(nWidth, nHeight, nPlanes, nBitsPerPixel, null), NativeMethods.CommonHandles.GDI);
        }

        public static IntPtr CreateBitmap(int nWidth, int nHeight, int nPlanes, int nBitsPerPixel, byte[] lpvBits)
        {
            return LabsB.Controls.Internal.HandleCollector.Add(IntCreateBitmapByte(nWidth, nHeight, nPlanes, nBitsPerPixel, lpvBits), NativeMethods.CommonHandles.GDI);
        }

        public static IntPtr CreateBitmap(int nWidth, int nHeight, int nPlanes, int nBitsPerPixel, short[] lpvBits)
        {
            return LabsB.Controls.Internal.HandleCollector.Add(IntCreateBitmapShort(nWidth, nHeight, nPlanes, nBitsPerPixel, lpvBits), NativeMethods.CommonHandles.GDI);
        }

        public static IntPtr CreateBitmap(int nWidth, int nHeight, int nPlanes, int nBitsPerPixel, IntPtr lpvBits)
        {
            return LabsB.Controls.Internal.HandleCollector.Add(IntCreateBitmap(nWidth, nHeight, nPlanes, nBitsPerPixel, lpvBits), NativeMethods.CommonHandles.GDI);
        }

        public static IntPtr CreateBitmap(int nWidth, int nHeight, int nPlanes, int nBitsPerPixel, int[] lpvBits)
        {
            return LabsB.Controls.Internal.HandleCollector.Add(IntCreateBitmap(nWidth, nHeight, nPlanes, nBitsPerPixel, lpvBits), NativeMethods.CommonHandles.GDI);
        }

        public static IntPtr CreateBrushIndirect(NativeMethods.LOGBRUSH lb)
        {
            return LabsB.Controls.Internal.HandleCollector.Add(IntCreateBrushIndirect(lb), NativeMethods.CommonHandles.GDI);
        }

        public static IntPtr CreateCompatibleBitmap(HandleRef hDC, int width, int height)
        {
            return LabsB.Controls.Internal.HandleCollector.Add(IntCreateCompatibleBitmap(hDC, width, height), NativeMethods.CommonHandles.GDI);
        }

        public static IntPtr CreateDIBSection(HandleRef hdc, HandleRef pbmi, int iUsage, byte[] ppvBits, IntPtr hSection, int dwOffset)
        {
            return LabsB.Controls.Internal.HandleCollector.Add(IntCreateDIBSection(hdc, pbmi, iUsage, ppvBits, hSection, dwOffset), NativeMethods.CommonHandles.GDI);
        }

        public static IntPtr CreateDIBSection(HandleRef hdc, HandleRef pbmi, int iUsage, int[] ppvBits, IntPtr hSection, int dwOffset)
        {
            return LabsB.Controls.Internal.HandleCollector.Add(IntCreateDIBSection(hdc, pbmi, iUsage, ppvBits, hSection, dwOffset), NativeMethods.CommonHandles.GDI);
        }

        public static IntPtr CreateDIBSection(HandleRef hdc, ref NativeMethods.BITMAPINFO_FLAT bmi, int iUsage, ref IntPtr ppvBits, IntPtr hSection, int dwOffset)
        {
            return LabsB.Controls.Internal.HandleCollector.Add(IntCreateDIBSection(hdc, ref bmi, iUsage, ref ppvBits, hSection, dwOffset), NativeMethods.CommonHandles.GDI);
        }

        public static IntPtr CreateDIBSection(HandleRef hdc, NativeMethods.BITMAPINFO bmi, int iUsage, ref IntPtr ppvBits, IntPtr hSection, int dwOffset)
        {
            return LabsB.Controls.Internal.HandleCollector.Add(IntCreateDIBSection(hdc, bmi, iUsage, ref ppvBits, hSection, dwOffset), NativeMethods.CommonHandles.GDI);
        }

        public static IntPtr CreateFontIndirect(object lf)
        {
            return LabsB.Controls.Internal.HandleCollector.Add(IntCreateFontIndirect(lf), NativeMethods.CommonHandles.GDI);
        }

        public static IntPtr CreateHalftonePalette(HandleRef hdc)
        {
            return LabsB.Controls.Internal.HandleCollector.Add(IntCreateHalftonePalette(hdc), NativeMethods.CommonHandles.GDI);
        }

        public static IntPtr CreateHatchBrush(int fnStyle, int crColor)
        {
            return LabsB.Controls.Internal.HandleCollector.Add(IntCreateHatchBrush(fnStyle, crColor), NativeMethods.CommonHandles.GDI);
        }

        public static IntPtr CreatePalette(HandleRef ptrlgpl)
        {
            return LabsB.Controls.Internal.HandleCollector.Add(IntCreatePalette(ptrlgpl), NativeMethods.CommonHandles.GDI);
        }

        public static IntPtr CreatePalette(NativeMethods.LOGPALETTE lplgpl)
        {
            return LabsB.Controls.Internal.HandleCollector.Add(IntCreatePalette(lplgpl), NativeMethods.CommonHandles.GDI);
        }

        public static IntPtr CreatePatternBrush(HandleRef hbmp)
        {
            return LabsB.Controls.Internal.HandleCollector.Add(IntCreatePatternBrush(hbmp), NativeMethods.CommonHandles.GDI);
        }

        public static IntPtr CreatePen(int nStyle, int nWidth, int crColor)
        {
            return LabsB.Controls.Internal.HandleCollector.Add(IntCreatePen(nStyle, nWidth, crColor), NativeMethods.CommonHandles.GDI);
        }

        public static IntPtr CreateRectRgn(int x1, int y1, int x2, int y2)
        {
            return LabsB.Controls.Internal.HandleCollector.Add(IntCreateRectRgn(x1, y1, x2, y2), NativeMethods.CommonHandles.GDI);
        }

        public static IntPtr CreateSolidBrush(int crColor)
        {
            return LabsB.Controls.Internal.HandleCollector.Add(IntCreateSolidBrush(crColor), NativeMethods.CommonHandles.GDI);
        }

        public static bool DeleteObject(HandleRef hObject)
        {
            LabsB.Controls.Internal.HandleCollector.Remove((IntPtr) hObject, NativeMethods.CommonHandles.GDI);
            return IntDeleteObject(hObject);
        }

        [DllImport("comctl32.dll")]
        public static extern void DllGetVersion(NativeMethods.DLLVERSIONINFO dllVersionInfo);
        [DllImport("ole32.dll", CharSet=CharSet.Auto, ExactSpelling=true)]
        public static extern int DoDragDrop(System.Windows.Forms.IDataObject dataObject, UnsafeNativeMethods.IOleDropSource dropSource, int allowedEffects, int[] finalEffect);
        [DllImport("gdi32.dll", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        public static extern bool DPtoLP(HandleRef hDC, [In, Out] ref NativeMethods.POINT lpRect, int nCount);
        [DllImport("gdi32.dll", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        public static extern bool DPtoLP(HandleRef hDC, [In, Out] ref NativeMethods.RECT lpRect, int nCount);
        [DllImport("user32.dll", CharSet=CharSet.Auto, ExactSpelling=true)]
        public static extern bool DrawEdge(HandleRef hDC, ref NativeMethods.RECT rect, int edge, int flags);
        [DllImport("user32.dll", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        public static extern bool DrawFocusRect(HandleRef hDc, ref NativeMethods.RECT lpRect);
        [DllImport("user32.dll", CharSet=CharSet.Auto, ExactSpelling=true)]
        public static extern bool DrawFrameControl(HandleRef hDC, ref NativeMethods.RECT rect, int type, int state);
        [DllImport("user32.dll", CharSet=CharSet.Auto, ExactSpelling=true)]
        public static extern bool DrawIcon(HandleRef hDC, int x, int y, HandleRef hIcon);
        [DllImport("user32.dll", CharSet=CharSet.Auto, ExactSpelling=true)]
        public static extern bool DrawIconEx(HandleRef hDC, int x, int y, HandleRef hIcon, int width, int height, int iStepIfAniCursor, HandleRef hBrushFlickerFree, int diFlags);
        [DllImport("user32.dll", CharSet=CharSet.Auto, ExactSpelling=true)]
        public static extern bool DrawMenuBar(HandleRef hWnd);
        [DllImport("user32.dll", CharSet=CharSet.Auto)]
        public static extern int DrawText(HandleRef hDC, string lpszString, int nCount, ref NativeMethods.RECT lpRect, int nFormat);
        [DllImport("user32.dll", CharSet=CharSet.Ansi)]
        public static extern int DrawText(HandleRef hDC, byte[] lpszString, int byteCount, ref NativeMethods.RECT lpRect, int nFormat);
        [DllImport("uxtheme.dll", CharSet=CharSet.Auto)]
        public static extern int DrawThemeBackground(HandleRef hTheme, HandleRef hdc, int partId, int stateId, [In] NativeMethods.COMRECT pRect, [In] NativeMethods.COMRECT pClipRect);
        [DllImport("uxtheme.dll", CharSet=CharSet.Auto)]
        public static extern int DrawThemeEdge(HandleRef hTheme, HandleRef hdc, int iPartId, int iStateId, [In] NativeMethods.COMRECT pDestRect, int uEdge, int uFlags, [Out] NativeMethods.COMRECT pContentRect);
        [DllImport("uxtheme.dll", CharSet=CharSet.Auto)]
        public static extern int DrawThemeIcon(HandleRef hTheme, HandleRef hdc, int iPartId, int iStateId, [In] NativeMethods.COMRECT pRect, HandleRef himl, int iImageIndex);
        [DllImport("uxtheme.dll", CharSet=CharSet.Auto)]
        public static extern int DrawThemeParentBackground(HandleRef hwnd, HandleRef hdc, [In] NativeMethods.COMRECT prc);
        [DllImport("uxtheme.dll", CharSet=CharSet.Auto)]
        public static extern int DrawThemeText(HandleRef hTheme, HandleRef hdc, int iPartId, int iStateId, [MarshalAs(UnmanagedType.LPWStr)] string pszText, int iCharCount, int dwTextFlags, int dwTextFlags2, [In] NativeMethods.COMRECT pRect);
        [DllImport("gdi32.dll", CharSet=CharSet.Auto, SetLastError=true)]
        public static extern bool Ellipse(HandleRef hDC, int nLeftRect, int nTopRect, int nRightRect, int nBottomRect);
        [DllImport("uxtheme.dll", CharSet=CharSet.Auto)]
        public static extern int EnableTheming(bool enable);
        [DllImport("user32.dll", CharSet=CharSet.Auto, ExactSpelling=true)]
        public static extern bool EnableWindow(HandleRef hWnd, bool enable);
        [DllImport("gdi32.dll", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        public static extern bool EndPath(HandleRef hDC);
        [DllImport("user32.dll", ExactSpelling=true)]
        public static extern bool EnumDisplayMonitors(HandleRef hdc, ref NativeMethods.RECT rcClip, NativeMethods.MonitorEnumProc lpfnEnum, IntPtr dwData);
        [DllImport("user32.dll", ExactSpelling=true)]
        public static extern bool EnumDisplayMonitors(HandleRef hdc, NativeMethods.COMRECT rcClip, NativeMethods.MonitorEnumProc lpfnEnum, IntPtr dwData);
        [DllImport("user32.dll", CharSet=CharSet.Auto)]
        public static extern bool EnumDisplaySettings(string lpszDeviceName, int iModeNum, ref NativeMethods.DEVMODE lpDevMode);
        [DllImport("gdi32.dll", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        public static extern int ExcludeClipRect(HandleRef hDC, int nLeftRect, int nTopRect, int nRightRect, int nBottomRect);
        public static IntPtr ExtCreatePen(int fnStyle, int dwWidth, NativeMethods.LOGBRUSH lplb, int dwStyleCount, int[] lpStyle)
        {
            return LabsB.Controls.Internal.HandleCollector.Add(IntExtCreatePen(fnStyle, dwWidth, lplb, dwStyleCount, lpStyle), NativeMethods.CommonHandles.GDI);
        }

        [DllImport("gdi32.dll", EntryPoint="DeleteObject", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        public static extern bool ExternalDeleteObject(HandleRef hObject);
        [DllImport("gdi32.dll", CharSet=CharSet.Auto, SetLastError=true)]
        internal static extern bool ExtTextOut(HandleRef hdc, int x, int y, int options, ref NativeMethods.RECT rect, string str, int length, int[] spacing);
        [DllImport("user32.dll", CharSet=CharSet.Auto, ExactSpelling=true)]
        public static extern int FillRect(HandleRef hdc, [In] ref NativeMethods.RECT rect, HandleRef hbrush);
        [DllImport("user32.dll", CharSet=CharSet.Auto, ExactSpelling=true)]
        public static extern bool FlashWindowEx(NativeMethods.FLASHWINFO flashInfo);
        [DllImport("kernel32.dll", CharSet=CharSet.Auto)]
        public static extern int FormatMessage(int dwFlags, HandleRef lpSource, int dwMessageId, int dwLanguageId, StringBuilder lpBuffer, int nSize, HandleRef arguments);
        [DllImport("kernel32.dll", CharSet=CharSet.Auto, ExactSpelling=true)]
        public static extern int GetACP();
        [DllImport("gdi32.dll", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        public static extern int GetBitmapBits(HandleRef hbmp, int cbBuffer, byte[] lpvBits);
        [DllImport("gdi32.dll", CharSet=CharSet.Auto, ExactSpelling=true)]
        public static extern int GetBkColor(HandleRef hDC);
        [DllImport("user32.dll", CharSet=CharSet.Auto, ExactSpelling=true)]
        public static extern bool GetClientRect(HandleRef hWnd, [In, Out] ref NativeMethods.RECT rect);
        [DllImport("user32.dll", CharSet=CharSet.Auto)]
        public static extern int GetClipboardFormatName(int format, StringBuilder lpString, int cchMax);
        [DllImport("user32.dll", CharSet=CharSet.Auto, ExactSpelling=true)]
        public static extern bool GetClipCursor([In, Out] ref NativeMethods.RECT lpRect);
        [DllImport("gdi32.dll", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        public static extern int GetClipRgn(HandleRef hDC, HandleRef hRgn);
        [DllImport("gdi32.dll", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        public static extern IntPtr GetCurrentObject(HandleRef hDC, uint uObjectType);
        [DllImport("kernel32.dll", CharSet=CharSet.Auto, ExactSpelling=true)]
        public static extern IntPtr GetCurrentProcess();
        [DllImport("kernel32.dll", CharSet=CharSet.Auto, ExactSpelling=true)]
        public static extern int GetCurrentProcessId();
        [DllImport("uxtheme.dll", CharSet=CharSet.Auto)]
        public static extern int GetCurrentThemeName(StringBuilder pszThemeFileName, int dwMaxNameChars, StringBuilder pszColorBuff, int dwMaxColorChars, StringBuilder pszSizeBuff, int cchMaxSizeChars);
        [DllImport("kernel32.dll", CharSet=CharSet.Auto, ExactSpelling=true)]
        public static extern IntPtr GetCurrentThread();
        [DllImport("kernel32.dll", CharSet=CharSet.Auto, ExactSpelling=true)]
        public static extern int GetCurrentThreadId();
        [DllImport("user32.dll", CharSet=CharSet.Auto, ExactSpelling=true)]
        public static extern IntPtr GetCursor();
        [DllImport("gdi32.dll")]
        public static extern IntPtr GetDIBits(HandleRef hdc, HandleRef hbm, int uStartScan, int cScanLines, byte[] lpvBits, ref NativeMethods.BITMAPINFO_FLAT bmi, int uUsage);
        [DllImport("gdi32.dll")]
        public static extern IntPtr GetDIBits(HandleRef hdc, HandleRef hbm, int arg1, int arg2, IntPtr arg3, ref NativeMethods.BITMAPINFO_FLAT bmi, int arg5);
        [DllImport("gdi32.dll")]
        public static extern IntPtr GetDIBits(HandleRef hdc, HandleRef hbm, int arg1, int arg2, IntPtr arg3, NativeMethods.BITMAPINFOHEADER bmi, int arg5);
        [DllImport("user32.dll", CharSet=CharSet.Auto, ExactSpelling=true)]
        public static extern int GetDoubleClickTime();
        [DllImport("user32.dll", CharSet=CharSet.Auto, ExactSpelling=true)]
        public static extern bool GetIconInfo(HandleRef hIcon, [In, Out] NativeMethods.ICONINFO info);
        [DllImport("user32.dll", CharSet=CharSet.Auto, ExactSpelling=true)]
        public static extern IntPtr GetKeyboardLayout(int dwLayout);
        [DllImport("user32.dll", CharSet=CharSet.Auto, ExactSpelling=true)]
        public static extern int GetKeyboardLayoutList(int size, [Out, MarshalAs(UnmanagedType.LPArray)] IntPtr[] hkls);
        [DllImport("user32.dll", ExactSpelling=true)]
        public static extern short GetKeyState(int keyCode);
        [DllImport("gdi32.dll", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        public static extern int GetMapMode(HandleRef hDC);
        [DllImport("user32.dll", CharSet=CharSet.Auto, ExactSpelling=true)]
        public static extern int GetMessagePos();
        [DllImport("user32.dll", CharSet=CharSet.Auto)]
        public static extern bool GetMonitorInfo(HandleRef hmonitor, [In, Out] NativeMethods.MONITORINFOEX info);
        [DllImport("gdi32.dll", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        public static extern int GetNearestColor(HandleRef hDC, int color);
        [DllImport("gdi32.dll")]
        public static extern IntPtr GetPaletteEntries(HandleRef hpal, int iStartIndex, int nEntries, byte[] lppe);
        [DllImport("gdi32.dll", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        public static extern int GetPaletteEntries(HandleRef hpal, int iStartIndex, int nEntries, int[] lppe);
        [DllImport("gdi32.dll", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        public static extern int GetPaletteEntries(HandleRef hpal, int iStartIndex, int nEntries, IntPtr lppe);
        [DllImport("gdi32.dll", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        public static extern int GetRegionData(HandleRef hRgn, int size, byte[] data);
        [DllImport("gdi32.dll", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        public static extern int GetRgnBox(HandleRef hRegion, ref NativeMethods.RECT clipRect);
        [DllImport("user32.dll", CharSet=CharSet.Auto, ExactSpelling=true)]
        public static extern bool GetScrollInfo(HandleRef hWnd, int fnBar, [In, Out] NativeMethods.SCROLLINFO si);
        [DllImport("gdi32.dll", CharSet=CharSet.Auto, SetLastError=true)]
        public static extern IntPtr GetStockObject(int fnObject);
        [DllImport("user32.dll", CharSet=CharSet.Auto, ExactSpelling=true)]
        public static extern IntPtr GetSysColorBrush(int nIndex);
        [DllImport("kernel32.dll", CharSet=CharSet.Auto)]
        public static extern int GetSystemDefaultLCID();
        [DllImport("gdi32.dll")]
        public static extern IntPtr GetSystemPaletteEntries(HandleRef hdc, int iStartIndex, int nEntries, byte[] lppe);
        [DllImport("gdi32.dll", CharSet=CharSet.Auto, ExactSpelling=true)]
        public static extern int GetTextColor(HandleRef hDC);
        [DllImport("gdi32.dll", CharSet=CharSet.Auto, SetLastError=true)]
        public static extern int GetTextExtentPoint32(HandleRef hDC, string str, int len, [In, Out] NativeMethods.SIZE size);
        public static int GetTextMetrics(HandleRef hDC, ref NativeMethods.TEXTMETRIC lptm)
        {
            if (Marshal.SystemDefaultCharSize == 1)
            {
                NativeMethods.TEXTMETRICA textmetrica = new NativeMethods.TEXTMETRICA();
                int textMetricsA = GetTextMetricsA(hDC, ref textmetrica);
                lptm.tmHeight = textmetrica.tmHeight;
                lptm.tmAscent = textmetrica.tmAscent;
                lptm.tmDescent = textmetrica.tmDescent;
                lptm.tmInternalLeading = textmetrica.tmInternalLeading;
                lptm.tmExternalLeading = textmetrica.tmExternalLeading;
                lptm.tmAveCharWidth = textmetrica.tmAveCharWidth;
                lptm.tmMaxCharWidth = textmetrica.tmMaxCharWidth;
                lptm.tmWeight = textmetrica.tmWeight;
                lptm.tmOverhang = textmetrica.tmOverhang;
                lptm.tmDigitizedAspectX = textmetrica.tmDigitizedAspectX;
                lptm.tmDigitizedAspectY = textmetrica.tmDigitizedAspectY;
                lptm.tmFirstChar = (char) textmetrica.tmFirstChar;
                lptm.tmLastChar = (char) textmetrica.tmLastChar;
                lptm.tmDefaultChar = (char) textmetrica.tmDefaultChar;
                lptm.tmBreakChar = (char) textmetrica.tmBreakChar;
                lptm.tmItalic = textmetrica.tmItalic;
                lptm.tmUnderlined = textmetrica.tmUnderlined;
                lptm.tmStruckOut = textmetrica.tmStruckOut;
                lptm.tmPitchAndFamily = textmetrica.tmPitchAndFamily;
                lptm.tmCharSet = textmetrica.tmCharSet;
                return textMetricsA;
            }
            return GetTextMetricsW(hDC, ref lptm);
        }

        [DllImport("gdi32.dll", CharSet=CharSet.Ansi, SetLastError=true, ExactSpelling=true)]
        public static extern int GetTextMetricsA(HandleRef hDC, [In, Out] ref NativeMethods.TEXTMETRICA lptm);
        [DllImport("gdi32.dll", CharSet=CharSet.Unicode, SetLastError=true, ExactSpelling=true)]
        public static extern int GetTextMetricsW(HandleRef hDC, [In, Out] ref NativeMethods.TEXTMETRIC lptm);
        [DllImport("uxtheme.dll", CharSet=CharSet.Auto)]
        public static extern int GetThemeAppProperties();
        [DllImport("uxtheme.dll", CharSet=CharSet.Auto)]
        public static extern int GetThemeBackgroundContentRect(HandleRef hTheme, HandleRef hdc, int iPartId, int iStateId, [In] NativeMethods.COMRECT pBoundingRect, [Out] NativeMethods.COMRECT pContentRect);
        [DllImport("uxtheme.dll", CharSet=CharSet.Auto)]
        public static extern int GetThemeBackgroundExtent(HandleRef hTheme, HandleRef hdc, int iPartId, int iStateId, [In] NativeMethods.COMRECT pContentRect, [Out] NativeMethods.COMRECT pExtentRect);
        [DllImport("uxtheme.dll", CharSet=CharSet.Auto)]
        public static extern int GetThemeBackgroundRegion(HandleRef hTheme, HandleRef hdc, int iPartId, int iStateId, [In] NativeMethods.COMRECT pRect, ref IntPtr pRegion);
        [DllImport("uxtheme.dll", CharSet=CharSet.Auto)]
        public static extern int GetThemeBool(HandleRef hTheme, int iPartId, int iStateId, int iPropId, ref bool pfVal);
        [DllImport("uxtheme.dll", CharSet=CharSet.Auto)]
        public static extern int GetThemeColor(HandleRef hTheme, int iPartId, int iStateId, int iPropId, ref int pColor);
        [DllImport("uxtheme.dll", CharSet=CharSet.Auto)]
        public static extern int GetThemeDocumentationProperty([MarshalAs(UnmanagedType.LPWStr)] string pszThemeName, [MarshalAs(UnmanagedType.LPWStr)] string pszPropertyName, StringBuilder pszValueBuff, int cchMaxValChars);
        [DllImport("uxtheme.dll", CharSet=CharSet.Auto)]
        public static extern int GetThemeEnumValue(HandleRef hTheme, int iPartId, int iStateId, int iPropId, ref int piVal);
        [DllImport("uxtheme.dll", CharSet=CharSet.Auto)]
        public static extern int GetThemeFilename(HandleRef hTheme, int iPartId, int iStateId, int iPropId, StringBuilder pszThemeFilename, int cchMaxBuffChars);
        [DllImport("uxtheme.dll", CharSet=CharSet.Auto)]
        public static extern int GetThemeFont(HandleRef hTheme, HandleRef hdc, int iPartId, int iStateId, int iPropId, NativeMethods.LOGFONT pFont);
        [DllImport("uxtheme.dll", CharSet=CharSet.Auto)]
        public static extern int GetThemeInt(HandleRef hTheme, int iPartId, int iStateId, int iPropId, ref int piVal);
        [DllImport("uxtheme.dll", CharSet=CharSet.Auto)]
        public static extern int GetThemeMargins(HandleRef hTheme, HandleRef hDC, int iPartId, int iStateId, int iPropId, ref NativeMethods.MARGINS margins);
        [DllImport("uxtheme.dll", CharSet=CharSet.Auto)]
        public static extern int GetThemePartSize(HandleRef hTheme, HandleRef hdc, int iPartId, int iStateId, [In] NativeMethods.COMRECT prc, ThemeSizeType eSize, [Out] NativeMethods.SIZE psz);
        [DllImport("uxtheme.dll", CharSet=CharSet.Auto)]
        public static extern int GetThemePosition(HandleRef hTheme, int iPartId, int iStateId, int iPropId, [Out] NativeMethods.POINT pPoint);
        [DllImport("uxtheme.dll", CharSet=CharSet.Auto)]
        public static extern int GetThemeString(HandleRef hTheme, int iPartId, int iStateId, int iPropId, StringBuilder pszBuff, int cchMaxBuffChars);
        [DllImport("uxtheme.dll", CharSet=CharSet.Auto)]
        public static extern bool GetThemeSysBool(HandleRef hTheme, int iBoolId);
        [DllImport("uxtheme.dll", CharSet=CharSet.Auto)]
        public static extern int GetThemeSysInt(HandleRef hTheme, int iIntId, ref int piValue);
        [DllImport("uxtheme.dll", CharSet=CharSet.Auto)]
        public static extern int GetThemeTextExtent(HandleRef hTheme, HandleRef hdc, int iPartId, int iStateId, [MarshalAs(UnmanagedType.LPWStr)] string pszText, int iCharCount, int dwTextFlags, [In] NativeMethods.COMRECT pBoundingRect, [Out] NativeMethods.COMRECT pExtentRect);
        [DllImport("uxtheme.dll", CharSet=CharSet.Auto)]
        public static extern int GetThemeTextMetrics(HandleRef hTheme, HandleRef hdc, int iPartId, int iStateId, ref TextMetrics ptm);
        [DllImport("kernel32.dll", EntryPoint="GetThreadLocale", CharSet=CharSet.Auto)]
        public static extern int GetThreadLCID();
        [DllImport("kernel32.dll", CharSet=CharSet.Auto, ExactSpelling=true)]
        public static extern int GetThreadLocale();
        [DllImport("kernel32.dll", CharSet=CharSet.Auto, ExactSpelling=true)]
        public static extern int GetTickCount();
        [DllImport("kernel32.dll", CharSet=CharSet.Auto)]
        public static extern int GetUserDefaultLCID();
        [DllImport("gdi32.dll", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        public static extern bool GetViewportExtEx(HandleRef hDC, [In, Out] NativeMethods.SIZE s);
        [DllImport("gdi32.dll", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        public static extern bool GetViewportOrgEx(HandleRef hDC, [In, Out] NativeMethods.POINT point);
        [DllImport("gdi32.dll", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        public static extern bool GetWindowExtEx(HandleRef hDC, [In, Out] NativeMethods.SIZE s);
        [DllImport("user32.dll", CharSet=CharSet.Auto)]
        public static extern int GetWindowTextLength(HandleRef hWnd);
        [DllImport("user32.dll", CharSet=CharSet.Auto, ExactSpelling=true)]
        public static extern int GetWindowThreadProcessId(HandleRef hWnd, out int lpdwProcessId);
        [DllImport("uxtheme.dll", CharSet=CharSet.Auto)]
        public static extern int HitTestThemeBackground(HandleRef hTheme, HandleRef hdc, int iPartId, int iStateId, int dwOptions, [In] NativeMethods.COMRECT pRect, HandleRef hrgn, [In] NativeMethods.POINT ptTest, ref int pwHitTestCode);
        [DllImport("hhctrl.ocx", CharSet=CharSet.Auto)]
        public static extern int HtmlHelp(HandleRef hwndCaller, [MarshalAs(UnmanagedType.LPTStr)] string pszFile, int uCommand, int dwData);
        [DllImport("hhctrl.ocx", CharSet=CharSet.Auto)]
        public static extern int HtmlHelp(HandleRef hwndCaller, [MarshalAs(UnmanagedType.LPTStr)] string pszFile, int uCommand, string dwData);
        [DllImport("hhctrl.ocx", CharSet=CharSet.Auto)]
        public static extern int HtmlHelp(HandleRef hwndCaller, [MarshalAs(UnmanagedType.LPTStr)] string pszFile, int uCommand, NativeMethods.HH_AKLINK dwData);
        [DllImport("hhctrl.ocx", CharSet=CharSet.Auto)]
        public static extern int HtmlHelp(HandleRef hwndCaller, [MarshalAs(UnmanagedType.LPTStr)] string pszFile, int uCommand, NativeMethods.HH_FTS_QUERY dwData);
        [DllImport("hhctrl.ocx", CharSet=CharSet.Auto)]
        public static extern int HtmlHelp(HandleRef hwndCaller, [MarshalAs(UnmanagedType.LPTStr)] string pszFile, int uCommand, NativeMethods.HH_POPUP dwData);
        [DllImport("comctl32.dll")]
        public static extern int ImageList_Add(HandleRef himl, HandleRef hbmImage, HandleRef hbmMask);
        [DllImport("comctl32.dll")]
        public static extern IntPtr ImageList_Create(int cx, int cy, int flags, int cInitial, int cGrow);
        [DllImport("comctl32.dll")]
        public static extern bool ImageList_Destroy(HandleRef himl);
        [DllImport("comctl32.dll")]
        public static extern bool ImageList_Draw(HandleRef himl, int i, HandleRef hdcDst, int x, int y, int fStyle);
        [DllImport("comctl32.dll")]
        public static extern bool ImageList_DrawEx(HandleRef himl, int i, HandleRef hdcDst, int x, int y, int dx, int dy, int rgbBk, int rgbFg, int fStyle);
        [DllImport("comctl32.dll")]
        public static extern bool ImageList_DrawIndirect(NativeMethods.IMAGELISTDRAWPARAMS pimldp);
        [DllImport("comctl32.dll")]
        public static extern IntPtr ImageList_Duplicate(HandleRef himl);
        [DllImport("comctl32.dll")]
        public static extern int ImageList_GetImageCount(HandleRef himl);
        [DllImport("comctl32.dll")]
        public static extern bool ImageList_GetImageInfo(HandleRef himl, int i, NativeMethods.IMAGEINFO pImageInfo);
        [DllImport("comctl32.dll")]
        public static extern IntPtr ImageList_Read(UnsafeNativeMethods.IStream pstm);
        [DllImport("comctl32.dll")]
        public static extern bool ImageList_Remove(HandleRef himl, int i);
        [DllImport("comctl32.dll")]
        public static extern bool ImageList_Replace(HandleRef himl, int i, HandleRef hbmImage, HandleRef hbmMask);
        [DllImport("comctl32.dll")]
        public static extern int ImageList_ReplaceIcon(HandleRef himl, int index, HandleRef hicon);
        [DllImport("comctl32.dll")]
        public static extern int ImageList_SetBkColor(HandleRef himl, int clrBk);
        [DllImport("comctl32.dll")]
        public static extern bool ImageList_Write(HandleRef himl, UnsafeNativeMethods.IStream pstm);
        [DllImport("comctl32.dll")]
        public static extern int ImageList_WriteEx(HandleRef himl, int dwFlags, UnsafeNativeMethods.IStream pstm);
        [DllImport("comctl32.dll")]
        public static extern void InitCommonControls();
        [DllImport("comctl32.dll")]
        public static extern bool InitCommonControlsEx(NativeMethods.INITCOMMONCONTROLSEX icc);
        [DllImport("user32.dll", EntryPoint="CopyImage", CharSet=CharSet.Auto, ExactSpelling=true)]
        private static extern IntPtr IntCopyImage(HandleRef hImage, int uType, int cxDesired, int cyDesired, int fuFlags);
        [DllImport("gdi32.dll", EntryPoint="CreateBitmap", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        private static extern IntPtr IntCreateBitmap(int nWidth, int nHeight, int nPlanes, int nBitsPerPixel, int[] lpvBits);
        [DllImport("gdi32.dll", EntryPoint="CreateBitmap", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        private static extern IntPtr IntCreateBitmap(int nWidth, int nHeight, int nPlanes, int nBitsPerPixel, IntPtr lpvBits);
        [DllImport("gdi32.dll", EntryPoint="CreateBitmap", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        private static extern IntPtr IntCreateBitmapByte(int nWidth, int nHeight, int nPlanes, int nBitsPerPixel, byte[] lpvBits);
        [DllImport("gdi32.dll", EntryPoint="CreateBitmap", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        private static extern IntPtr IntCreateBitmapShort(int nWidth, int nHeight, int nPlanes, int nBitsPerPixel, short[] lpvBits);
        [DllImport("gdi32.dll", EntryPoint="CreateBrushIndirect", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        private static extern IntPtr IntCreateBrushIndirect(NativeMethods.LOGBRUSH lb);
        [DllImport("gdi32.dll", EntryPoint="CreateCompatibleBitmap", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        public static extern IntPtr IntCreateCompatibleBitmap(HandleRef hDC, int width, int height);
        [DllImport("gdi32.dll", EntryPoint="CreateDIBSection", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        private static extern IntPtr IntCreateDIBSection(HandleRef hdc, HandleRef pbmi, int iUsage, byte[] ppvBits, IntPtr hSection, int dwOffset);
        [DllImport("gdi32.dll", EntryPoint="CreateDIBSection", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        private static extern IntPtr IntCreateDIBSection(HandleRef hdc, HandleRef pbmi, int iUsage, int[] ppvBits, IntPtr hSection, int dwOffset);
        [DllImport("gdi32.dll", EntryPoint="CreateDIBSection", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        public static extern IntPtr IntCreateDIBSection(HandleRef hdc, ref NativeMethods.BITMAPINFO_FLAT bmi, int iUsage, ref IntPtr ppvBits, IntPtr hSection, int dwOffset);
        [DllImport("gdi32.dll", EntryPoint="CreateDIBSection", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        private static extern IntPtr IntCreateDIBSection(HandleRef hdc, NativeMethods.BITMAPINFO bmi, int iUsage, ref IntPtr ppvBits, IntPtr hSection, int dwOffset);
        [DllImport("gdi32.dll", EntryPoint="CreateFontIndirect", CharSet=CharSet.Auto, SetLastError=true)]
        public static extern IntPtr IntCreateFontIndirect([In, Out, MarshalAs(UnmanagedType.AsAny)] object lf);
        [DllImport("gdi32.dll", EntryPoint="CreateHalftonePalette", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        private static extern IntPtr IntCreateHalftonePalette(HandleRef hdc);
        [DllImport("gdi32.dll", EntryPoint="CreateHatchBrush", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        private static extern IntPtr IntCreateHatchBrush(int fnStyle, int crColor);
        [DllImport("gdi32.dll", EntryPoint="CreatePalette", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        private static extern IntPtr IntCreatePalette(HandleRef ptrlgpl);
        [DllImport("gdi32.dll", EntryPoint="CreatePalette", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        private static extern IntPtr IntCreatePalette(NativeMethods.LOGPALETTE lplgpl);
        [DllImport("gdi32.dll", EntryPoint="CreatePatternBrush", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        private static extern IntPtr IntCreatePatternBrush(HandleRef hbmp);
        [DllImport("gdi32.dll", EntryPoint="CreatePen", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        private static extern IntPtr IntCreatePen(int nStyle, int nWidth, int crColor);
        [DllImport("gdi32.dll", EntryPoint="CreateRectRgn", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        private static extern IntPtr IntCreateRectRgn(int x1, int y1, int x2, int y2);
        [DllImport("gdi32.dll", EntryPoint="CreateSolidBrush", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        private static extern IntPtr IntCreateSolidBrush(int crColor);
        [DllImport("gdi32.dll", EntryPoint="DeleteObject", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        private static extern bool IntDeleteObject(HandleRef hObject);
        [DllImport("gdi32.dll", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        public static extern int IntersectClipRect(HandleRef hDC, int x1, int y1, int x2, int y2);
        [DllImport("gdi32.dll", EntryPoint="ExtCreatePen", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        private static extern IntPtr IntExtCreatePen(int fnStyle, int dwWidth, NativeMethods.LOGBRUSH lplb, int dwStyleCount, [MarshalAs(UnmanagedType.LPArray)] int[] lpStyle);
        [DllImport("user32.dll", CharSet=CharSet.Auto, ExactSpelling=true)]
        public static extern bool InvalidateRect(HandleRef hWnd, NativeMethods.COMRECT rect, bool erase);
        [DllImport("user32.dll", CharSet=CharSet.Auto, ExactSpelling=true)]
        public static extern bool InvalidateRect(HandleRef hWnd, ref NativeMethods.RECT rect, bool erase);
        [DllImport("user32.dll", CharSet=CharSet.Auto, ExactSpelling=true)]
        public static extern bool InvalidateRgn(HandleRef hWnd, HandleRef hrgn, bool erase);
        [DllImport("ole32.dll", CharSet=CharSet.Auto, ExactSpelling=true)]
        public static extern bool IsAccelerator(HandleRef hAccel, int cAccelEntries, [In] ref NativeMethods.MSG lpMsg, short[] lpwCmd);
        [DllImport("uxtheme.dll", CharSet=CharSet.Auto)]
        public static extern bool IsAppThemed();
        [DllImport("user32.dll", CharSet=CharSet.Auto, ExactSpelling=true)]
        public static extern bool IsChild(HandleRef parent, HandleRef child);
        [DllImport("uxtheme.dll", CharSet=CharSet.Auto)]
        public static extern bool IsThemeBackgroundPartiallyTransparent(HandleRef hTheme, int iPartId, int iStateId);
        [DllImport("uxtheme.dll", CharSet=CharSet.Auto)]
        public static extern bool IsThemePartDefined(HandleRef hTheme, int iPartId, int iStateId);
        [DllImport("user32.dll", CharSet=CharSet.Auto, ExactSpelling=true)]
        public static extern bool IsWindowEnabled(HandleRef hWnd);
        [DllImport("user32.dll", CharSet=CharSet.Auto, ExactSpelling=true)]
        public static extern bool IsWindowUnicode(HandleRef hWnd);
        [DllImport("user32.dll", CharSet=CharSet.Auto, ExactSpelling=true)]
        public static extern bool IsWindowVisible(HandleRef hWnd);
        [DllImport("user32.dll", CharSet=CharSet.Auto, ExactSpelling=true)]
        public static extern bool KillTimer(HandleRef hwnd, int idEvent);
        [DllImport("gdi32.dll", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        public static extern bool LineTo(HandleRef hdc, int x, int y);
        [DllImport("user32.dll", CharSet=CharSet.Auto)]
        public static extern IntPtr LoadCursor(HandleRef hInst, int iconId);
        [DllImport("oleaut32.dll", CharSet=CharSet.Unicode)]
        public static extern int LoadTypeLib(string file, out ITypeLib typelib);
        [DllImport("user32.dll", CharSet=CharSet.Auto, ExactSpelling=true)]
        public static extern int LockWindowUpdate(HandleRef hDC);
        [DllImport("gdi32.dll", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        public static extern bool LPtoDP(HandleRef hDC, [In, Out] ref NativeMethods.RECT lpRect, int nCount);
        [DllImport("gdi32.dll")]
        public static extern bool LPtoDP(HandleRef hDC, int lpPoints, int nCount);
        [DllImport("gdi32.dll")]
        public static extern bool LPtoDP(HandleRef hDC, [In, Out] NativeMethods.POINT lpPoint, int nCount);
        [DllImport("gdi32.dll", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        public static extern bool LPtoDP(HandleRef hDC, [In, Out] NativeMethods.SIZE lpSize, int nCount);
        [DllImport("user32.dll", CharSet=CharSet.Auto, ExactSpelling=true)]
        public static extern bool MessageBeep(int type);
        [DllImport("user32.dll", CharSet=CharSet.Auto)]
        public static extern int MessageBox(HandleRef hWnd, string text, string caption, int type);
        [DllImport("gdi32.dll", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        public static extern bool ModifyWorldTransform(HandleRef hdc, NativeMethods.XFORM lpXform, int iMode);
        [DllImport("user32.dll", ExactSpelling=true)]
        public static extern IntPtr MonitorFromPoint(NativeMethods.POINTSTRUCT pt, int flags);
        [DllImport("user32.dll", ExactSpelling=true)]
        public static extern IntPtr MonitorFromRect(ref NativeMethods.RECT rect, int flags);
        [DllImport("user32.dll", ExactSpelling=true)]
        public static extern IntPtr MonitorFromWindow(HandleRef handle, int flags);
        [DllImport("gdi32.dll", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        public static extern bool MoveToEx(HandleRef hdc, int x, int y, NativeMethods.POINT pt);
        [DllImport("user32.dll")]
        public static extern int OemKeyScan(short wAsciiVal);
        [DllImport("gdi32.dll", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        public static extern bool OffsetWindowOrgEx(HandleRef hDC, int x, int y, [In, Out] NativeMethods.POINT point);
        [DllImport("oleaut32.dll", PreserveSig=false)]
        public static extern IFont OleCreateFontIndirect(NativeMethods.tagFONTDESC fontdesc, [In] ref Guid refiid);
        [DllImport("olepro32.dll", EntryPoint="OleCreateFontIndirect", ExactSpelling=true, PreserveSig=false)]
        public static extern IFontDisp OleCreateIFontDispIndirect(NativeMethods.FONTDESC fd, ref Guid iid);
        [DllImport("olepro32.dll", EntryPoint="OleCreateFontIndirect", ExactSpelling=true, PreserveSig=false)]
        public static extern IFont OleCreateIFontIndirect(NativeMethods.FONTDESC fd, ref Guid iid);
        [DllImport("olepro32.dll", EntryPoint="OleCreatePictureIndirect", ExactSpelling=true, PreserveSig=false)]
        public static extern IPictureDisp OleCreateIPictureDispIndirect([MarshalAs(UnmanagedType.AsAny)] object pictdesc, ref Guid iid, bool fOwn);
        [DllImport("olepro32.dll", EntryPoint="OleCreatePictureIndirect", ExactSpelling=true, PreserveSig=false)]
        public static extern IPicture OleCreateIPictureIndirect([MarshalAs(UnmanagedType.AsAny)] object pictdesc, ref Guid iid, bool fOwn);
        [DllImport("oleaut32.dll", PreserveSig=false)]
        public static extern IPicture OleCreatePictureIndirect(NativeMethods.PICTDESC pictdesc, [In] ref Guid refiid, bool fOwn);
        [DllImport("olepro32.dll", PreserveSig=false)]
        public static extern void OleCreatePropertyFrame(HandleRef hwndOwner, int x, int y, [MarshalAs(UnmanagedType.LPWStr)] string caption, int objects, [MarshalAs(UnmanagedType.Interface)] ref object pobjs, int pages, HandleRef pClsid, int locale, int reserved1, IntPtr reserved2);
        [DllImport("olepro32.dll", PreserveSig=false)]
        public static extern void OleCreatePropertyFrame(HandleRef hwndOwner, int x, int y, [MarshalAs(UnmanagedType.LPWStr)] string caption, int objects, HandleRef lplpobjs, int pages, HandleRef pClsid, int locale, int reserved1, IntPtr reserved2);
        [DllImport("olepro32.dll", PreserveSig=false)]
        public static extern void OleCreatePropertyFrame(HandleRef hwndOwner, int x, int y, [MarshalAs(UnmanagedType.LPWStr)] string caption, int objects, [MarshalAs(UnmanagedType.Interface)] ref object pobjs, int pages, Guid[] pClsid, int locale, int reserved1, IntPtr reserved2);
        [DllImport("oleaut32.dll", PreserveSig=false)]
        public static extern IPicture OleLoadPicture(UnsafeNativeMethods.IStream pStream, int lSize, bool fRunmode, ref Guid refiid);
        [DllImport("uxtheme.dll", CharSet=CharSet.Auto)]
        public static extern IntPtr OpenThemeData(HandleRef hwnd, [MarshalAs(UnmanagedType.LPWStr)] string pszClassList);
        [DllImport("gdi32.dll", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        public static extern bool PatBlt(HandleRef hdc, int left, int top, int width, int height, int rop);
        [DllImport("gdi32.dll", CharSet=CharSet.Auto, SetLastError=true)]
        public static extern bool Pie(HandleRef hDC, int nLeftRect, int nTopRect, int nRightRect, int nBottomRect, int nXRadial1, int nYRadial1, int nXRadial2, int nYRadial2);
        [DllImport("gdi32.dll", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        public static extern bool Polygon(HandleRef hDC, NativeMethods.POINT[] points, int nCount);
        [DllImport("gdi32.dll", CharSet=CharSet.Auto, SetLastError=true)]
        public static extern bool Polyline(HandleRef hDC, int[] points, int cPoints);
        [DllImport("gdi32.dll", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        public static extern int RealizePalette(HandleRef hDC);
        [DllImport("gdi32.dll", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        public static extern bool Rectangle(HandleRef hdc, int left, int top, int right, int bottom);
        [DllImport("user32.dll", CharSet=CharSet.Auto, ExactSpelling=true)]
        public static extern bool RedrawWindow(HandleRef hwnd, NativeMethods.COMRECT rcUpdate, HandleRef hrgnUpdate, int flags);
        [DllImport("user32.dll", CharSet=CharSet.Auto, ExactSpelling=true)]
        public static extern bool RedrawWindow(HandleRef hwnd, ref NativeMethods.RECT rcUpdate, HandleRef hrgnUpdate, int flags);
        [DllImport("user32.dll", CharSet=CharSet.Auto, SetLastError=true)]
        public static extern int RegisterClipboardFormat(string format);
        [DllImport("oleaut32.dll", CharSet=CharSet.Unicode)]
        public static extern int RegisterTypeLib(ITypeLib typelib, string path, string helpPath);
        [DllImport("user32.dll", CharSet=CharSet.Auto)]
        public static extern int RegisterWindowMessage(string msg);
        [DllImport("user32.dll", CharSet=CharSet.Auto, ExactSpelling=true)]
        public static extern bool ReleaseCapture();
        [DllImport("gdi32.dll", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        public static extern bool RestoreDC(HandleRef hDC, int nSavedDC);
        public static int RGBToCOLORREF(int rgbValue)
        {
            int num = (rgbValue & 0xff) << 0x10;
            rgbValue &= 0xffff00;
            rgbValue |= (rgbValue >> 0x10) & 0xff;
            rgbValue &= 0xffff;
            rgbValue |= num;
            return rgbValue;
        }

        [DllImport("gdi32.dll", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        public static extern int SaveDC(HandleRef hDC);
        [DllImport("user32.dll", CharSet=CharSet.Auto, ExactSpelling=true)]
        public static extern bool ScrollWindow(HandleRef hWnd, int nXAmount, int nYAmount, ref NativeMethods.RECT rectScrollRegion, ref NativeMethods.RECT rectClip);
        [DllImport("user32.dll", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        public static extern int ScrollWindowEx(HandleRef hWnd, int nXAmount, int nYAmount, ref NativeMethods.RECT rectScrollRegion, ref NativeMethods.RECT rectClip, HandleRef hrgnUpdate, ref NativeMethods.RECT prcUpdate, int flags);
        [DllImport("user32.dll", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        public static extern int ScrollWindowEx(HandleRef hWnd, int nXAmount, int nYAmount, NativeMethods.COMRECT rectScrollRegion, NativeMethods.COMRECT rectClip, HandleRef hrgnUpdate, ref NativeMethods.RECT prcUpdate, int flags);
        [DllImport("user32.dll", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        public static extern int ScrollWindowEx(HandleRef hWnd, int nXAmount, int nYAmount, NativeMethods.COMRECT rectScrollRegion, ref NativeMethods.RECT rectClip, HandleRef hrgnUpdate, ref NativeMethods.RECT prcUpdate, int flags);
        [DllImport("user32.dll", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        public static extern int ScrollWindowEx(HandleRef hWnd, int nXAmount, int nYAmount, ref NativeMethods.RECT rectScrollRegion, ref NativeMethods.RECT rectClip, HandleRef hrgnUpdate, NativeMethods.COMRECT prcUpdate, int flags);
        [DllImport("user32.dll", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        public static extern int ScrollWindowEx(HandleRef hWnd, int nXAmount, int nYAmount, NativeMethods.COMRECT rectScrollRegion, NativeMethods.COMRECT rectClip, HandleRef hrgnUpdate, NativeMethods.COMRECT prcUpdate, int flags);
        [DllImport("gdi32.dll", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        public static extern int SelectClipRgn(HandleRef hDC, HandleRef hRgn);
        [DllImport("gdi32.dll", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        public static extern IntPtr SelectObject(HandleRef hdc, int obj);
        [DllImport("gdi32.dll", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        public static extern IntPtr SelectObject(HandleRef hDC, HandleRef hObject);
        [DllImport("gdi32.dll", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        public static extern IntPtr SelectPalette(HandleRef hdc, HandleRef hpal, int bForceBackground);
        [DllImport("gdi32.dll", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        public static extern int SetBkColor(HandleRef hDC, int clr);
        [DllImport("gdi32.dll", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        public static extern int SetBkMode(HandleRef hDC, int nBkMode);
        [DllImport("gdi32.dll", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        public static extern int SetGraphicsMode(HandleRef hDC, int iMode);
        [DllImport("gdi32.dll", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        public static extern int SetMapMode(HandleRef hDC, int nMapMode);
        [DllImport("gdi32.dll", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        public static extern int SetPolyFillMode(HandleRef hDC, int nPolyFillMode);
        [DllImport("gdi32.dll", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        public static extern int SetROP2(HandleRef hDC, int nDrawMode);
        [DllImport("gdi32.dll", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        public static extern int SetTextAlign(HandleRef hDC, int nMode);
        [DllImport("gdi32.dll", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        public static extern int SetTextColor(HandleRef hDC, int crColor);
        [DllImport("uxtheme.dll", CharSet=CharSet.Auto)]
        public static extern void SetThemeAppProperties(int Flags);
        [DllImport("kernel32.dll", CharSet=CharSet.Auto, ExactSpelling=true)]
        public static extern bool SetThreadLocale(int Locale);
        [DllImport("user32.dll", CharSet=CharSet.Auto, ExactSpelling=true)]
        public static extern IntPtr SetTimer(HandleRef hWnd, int nIDEvent, int uElapse, NativeMethods.TimerProc lpTimerFunc);
        [DllImport("gdi32.dll", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        public static extern bool SetViewportExtEx(HandleRef hDC, int x, int y, NativeMethods.SIZE size);
        [DllImport("gdi32.dll", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        public static extern bool SetViewportOrgEx(HandleRef hDC, int x, int y, [In, Out] NativeMethods.POINT point);
        [DllImport("gdi32.dll", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        public static extern bool SetWindowExtEx(HandleRef hDC, int x, int y, [In, Out] NativeMethods.SIZE size);
        [DllImport("gdi32.dll", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        public static extern bool SetWindowOrgEx(HandleRef hDC, int x, int y, [In, Out] NativeMethods.POINT point);
        [DllImport("user32.dll", CharSet=CharSet.Auto, ExactSpelling=true)]
        public static extern bool SetWindowPos(HandleRef hWnd, HandleRef hWndInsertAfter, int x, int y, int cx, int cy, int flags);
        [DllImport("gdi32.dll", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        public static extern bool SetWorldTransform(HandleRef hDC, NativeMethods.XFORM xform);
        [DllImport("shlwapi.dll")]
        public static extern int SHAutoComplete(HandleRef hwndEdit, int flags);
        [DllImport("shell32.dll", CharSet=CharSet.Auto)]
        public static extern IntPtr SHGetFileInfo(string pszPath, int dwFileAttributes, NativeMethods.SHFILEINFO info, int cbFileInfo, int flags);
        [DllImport("user32.dll", CharSet=CharSet.Auto, ExactSpelling=true)]
        public static extern bool ShowWindow(HandleRef hWnd, int nCmdShow);
        [DllImport("gdi32.dll")]
        public static extern int StretchDIBits(HandleRef hdc, int XDest, int YDest, int nDestWidth, int nDestHeight, int XSrc, int YSrc, int nSrcWidth, int nSrcHeight, byte[] lpBits, ref NativeMethods.BITMAPINFO_FLAT lpBitsInfo, int iUsage, int dwRop);
        [DllImport("gdi32.dll", CharSet=CharSet.Auto, SetLastError=true, ExactSpelling=true)]
        public static extern bool StrokePath(HandleRef hDC);
        [DllImport("oleaut32.dll", CharSet=CharSet.Unicode, ExactSpelling=true)]
        public static extern void SysFreeString(HandleRef bstr);
        public static bool TrackMouseEvent(NativeMethods.TRACKMOUSEEVENT tme)
        {
            return _TrackMouseEvent(tme);
        }

        [DllImport("user32.dll", CharSet=CharSet.Auto, ExactSpelling=true)]
        public static extern bool TrackPopupMenuEx(HandleRef hmenu, int fuFlags, int x, int y, HandleRef hwnd, NativeMethods.TPMPARAMS tpm);
        [DllImport("user32.dll", CharSet=CharSet.Auto, ExactSpelling=true)]
        public static extern bool UpdateWindow(HandleRef hWnd);
        [DllImport("oleaut32.dll", PreserveSig=false)]
        public static extern void VariantClear(HandleRef pObject);
        [DllImport("oleaut32.dll", PreserveSig=false)]
        public static extern void VariantInit(HandleRef pObject);

        [ComImport, Guid("BEF6E002-A874-101A-8BBA-00AA00300CAB"), InterfaceType(ComInterfaceType.InterfaceIsIUnknown)]
        public interface IFont
        {
            [return: MarshalAs(UnmanagedType.BStr)]
            string GetName();
            void SetName([In, MarshalAs(UnmanagedType.BStr)] string pname);
            [return: MarshalAs(UnmanagedType.U8)]
            long GetSize();
            void SetSize([In, MarshalAs(UnmanagedType.U8)] long psize);
            [return: MarshalAs(UnmanagedType.Bool)]
            bool GetBold();
            void SetBold([In, MarshalAs(UnmanagedType.Bool)] bool pbold);
            [return: MarshalAs(UnmanagedType.Bool)]
            bool GetItalic();
            void SetItalic([In, MarshalAs(UnmanagedType.Bool)] bool pitalic);
            [return: MarshalAs(UnmanagedType.Bool)]
            bool GetUnderline();
            void SetUnderline([In, MarshalAs(UnmanagedType.Bool)] bool punderline);
            [return: MarshalAs(UnmanagedType.Bool)]
            bool GetStrikethrough();
            void SetStrikethrough([In, MarshalAs(UnmanagedType.Bool)] bool pstrikethrough);
            [return: MarshalAs(UnmanagedType.I2)]
            short GetWeight();
            void SetWeight([In, MarshalAs(UnmanagedType.I2)] short pweight);
            [return: MarshalAs(UnmanagedType.I2)]
            short GetCharset();
            void SetCharset([In, MarshalAs(UnmanagedType.I2)] short pcharset);
            IntPtr GetHFont();
            void Clone(out SafeNativeMethods.IFont ppfont);
            [PreserveSig]
            int IsEqual([In, MarshalAs(UnmanagedType.Interface)] SafeNativeMethods.IFont pfontOther);
            void SetRatio(int cyLogical, int cyHimetric);
            void QueryTextMetrics(out IntPtr ptm);
            void AddRefHfont(IntPtr hFont);
            void ReleaseHfont(IntPtr hFont);
            void SetHdc(IntPtr hdc);
        }

        [ComImport, Guid("BEF6E003-A874-101A-8BBA-00AA00300CAB"), InterfaceType(ComInterfaceType.InterfaceIsIDispatch)]
        public interface IFontDisp
        {
            string Name { get; set; }
            long Size { get; set; }
            bool Bold { get; set; }
            bool Italic { get; set; }
            bool Underline { get; set; }
            bool Strikethrough { get; set; }
            short Weight { get; set; }
            short Charset { get; set; }
        }

        [ComImport, InterfaceType(ComInterfaceType.InterfaceIsIUnknown), Guid("7BF80980-BF32-101A-8BBB-00AA00300CAB")]
        public interface IPicture
        {
            IntPtr GetHandle();
            IntPtr GetHPal();
            [return: MarshalAs(UnmanagedType.I2)]
            short GetPictureType();
            int GetWidth();
            int GetHeight();
            void Render(IntPtr hDC, int x, int y, int cx, int cy, int xSrc, int ySrc, int cxSrc, int cySrc, IntPtr rcBounds);
            void SetHPal(IntPtr phpal);
            IntPtr GetCurDC();
            void SelectPicture(IntPtr hdcIn, [Out, MarshalAs(UnmanagedType.LPArray)] IntPtr[] phdcOut, [Out, MarshalAs(UnmanagedType.LPArray)] IntPtr[] phbmpOut);
            [return: MarshalAs(UnmanagedType.Bool)]
            bool GetKeepOriginalFormat();
            void SetKeepOriginalFormat([In, MarshalAs(UnmanagedType.Bool)] bool pfkeep);
            void PictureChanged();
            [PreserveSig]
            int SaveAsFile([In, MarshalAs(UnmanagedType.Interface)] UnsafeNativeMethods.IStream pstm, int fSaveMemCopy, out int pcbSize);
            int GetAttributes();
        }

        [ComImport, Guid("7BF80981-BF32-101A-8BBB-00AA00300CAB"), InterfaceType(ComInterfaceType.InterfaceIsIDispatch)]
        public interface IPictureDisp
        {
            IntPtr Handle { get; }
            IntPtr HPal { get; }
            short PictureType { get; }
            int Width { get; }
            int Height { get; }
            void Render(IntPtr hdc, int x, int y, int cx, int cy, int xSrc, int ySrc, int cxSrc, int cySrc);
        }

        [SuppressUnmanagedCodeSecurity]
        internal class ThemingScope
        {
            private const int ACTCTX_FLAG_ASSEMBLY_DIRECTORY_VALID = 4;
            private static bool contextCreationSucceeded = false;
            [ThreadStatic]
            private static IntPtr cookie;
            private static ACTCTX enableThemingActivationContext;
            private static IntPtr hActCtx;

            public static bool Activate()
            {
                bool flag = false;
                if ((!(cookie == IntPtr.Zero) || !contextCreationSucceeded) || !OSFeature.Feature.IsPresent(OSFeature.Themes))
                {
                    return flag;
                }
                if (!ActivateActCtx(hActCtx, out cookie))
                {
                    cookie = IntPtr.Zero;
                    return flag;
                }
                return true;
            }

            [DllImport("kernel32.dll")]
            private static extern bool ActivateActCtx(IntPtr hActCtx, out IntPtr lpCookie);
            [DllImport("kernel32.dll")]
            private static extern IntPtr CreateActCtx(ref ACTCTX actctx);
            public static bool CreateActivationContext(string manifestFullName)
            {
                lock (typeof(SafeNativeMethods.ThemingScope))
                {
                    if (!contextCreationSucceeded && OSFeature.Feature.IsPresent(OSFeature.Themes))
                    {
                        string path = null;
                        FileIOPermission permission = new FileIOPermission(PermissionState.None);
                        permission.AllFiles = FileIOPermissionAccess.PathDiscovery;
                        permission.Assert();
                        try
                        {
                            path = typeof(object).Assembly.Location;
                        }
                        finally
                        {
                            CodeAccessPermission.RevertAssert();
                        }
                        enableThemingActivationContext = new ACTCTX();
                        enableThemingActivationContext.cbSize = Marshal.SizeOf(typeof(ACTCTX));
                        enableThemingActivationContext.lpSource = manifestFullName;
                        enableThemingActivationContext.lpAssemblyDirectory = Path.GetDirectoryName(path);
                        enableThemingActivationContext.dwFlags = 4;
                        hActCtx = CreateActCtx(ref enableThemingActivationContext);
                        contextCreationSucceeded = hActCtx != new IntPtr(-1);
                    }
                    return contextCreationSucceeded;
                }
            }

            public static bool Deactivate()
            {
                bool flag = false;
                if (((cookie != IntPtr.Zero) && OSFeature.Feature.IsPresent(OSFeature.Themes)) && DeactivateActCtx(0, cookie))
                {
                    cookie = IntPtr.Zero;
                    flag = true;
                }
                return flag;
            }

            [DllImport("kernel32.dll")]
            private static extern bool DeactivateActCtx(int dwFlags, IntPtr lpCookie);
            public static IntPtr ExplicitActivate()
            {
                IntPtr zero = IntPtr.Zero;
                if ((contextCreationSucceeded && OSFeature.Feature.IsPresent(OSFeature.Themes)) && !ActivateActCtx(hActCtx, out zero))
                {
                    zero = IntPtr.Zero;
                }
                return zero;
            }

            public static IntPtr ExplicitDeactivate(IntPtr userCookie)
            {
                if (((userCookie != IntPtr.Zero) && OSFeature.Feature.IsPresent(OSFeature.Themes)) && DeactivateActCtx(0, userCookie))
                {
                    userCookie = IntPtr.Zero;
                }
                return userCookie;
            }

            [StructLayout(LayoutKind.Sequential)]
            private struct ACTCTX
            {
                public int cbSize;
                public uint dwFlags;
                public string lpSource;
                public ushort wProcessorArchitecture;
                public ushort wLangId;
                public string lpAssemblyDirectory;
                public string lpResourceName;
                public string lpApplicationName;
            }
        }
    }
}

